/**
 * Hello World: Step 1
 *
 * Simple block, renders and saves the same content without interactivity.
 *
 * Using inline styles - no external stylesheet needed.  Not recommended
 * because all of these styles will appear in `post_content`.
 */

/*
if (typeof window.tmBlockHelper == 'undefined') window.tmBlockHelper = {};

window.tmBlockHelper.blockEvent = function (e) {
//jQuery(document.body).bind("dragover", function (e) {
e.preventDefault();
e.stopPropagation();
console.log("blocking");
return false;
//});
}

 */
import classnames from 'classnames';
import {
	Fragment
}
from '@wordpress/element';

import {
	__
}
from '@wordpress/i18n';
import {
	InspectorControls
}
from '@wordpress/editor';
import {
	BaseControl,
	PanelBody,
	ResizableBox,
	G,
	SVG,
	Path
}
from '@wordpress/components';
import {
	withInstanceId
}
from '@wordpress/compose';

import {
	Button,
	Notice,
	Popover,
	SelectControl
}
from '@wordpress/components';
import {
	withState
}
from '@wordpress/compose';

(function (blocks, editor, i18n, element, components, _) {

	function decodeHtml(html) {
		var txt = document.createElement("textarea");
		txt.innerHTML = html;
		return txt.value;
	}

	var __ = wp.i18n.__; // The __() function for internationalization.
	var createElement = wp.element.createElement; // The wp.element.createElement() function to create elements.
	var registerBlockType = wp.blocks.registerBlockType; // The registerBlockType() function to register blocks.

	var el = element.createElement;
	var __ = i18n.__;
	var RichText = editor.RichText;
	var AlignmentToolbar = editor.AlignmentToolbar;
	var BlockControls = editor.BlockControls;
	var InspectorControls = editor.InspectorControls; // For adding block controls.
	var ToggleControl = wp.components.ToggleControl; // For adding toggle controls to block settings panels.
	var ResizableBox = wp.components.ResizableBox;

	//console.log(editor);

	var blockStyle = {
		backgroundColor: '#900',
		color: '#fff',
		padding: '20px',
	};

	registerBlockType('thoughtmap/map', {
		title: __('Thought Map'),
		description: __('Embeds a thought map'),
		icon: 'share',
		category: 'common',
		supports: {
			multiple: false,
			reusable: false,
			html: false,
		},
		attributes: {
			height: {
				type: 'number',
			default:
				400,
			},
			mapID: {
				type: 'string',
				//default: 'No map chosen',
			},
			mapName: {
				type: 'string',
			default:
				'No map chosen',
			},
		},
		load: function (props) {
			console.log("loaded");
			//console.log(props);
		},
		edit: withInstanceId(
			({
				attributes,
				isSelected,
				setAttributes,
				toggleSelection,
				instanceId
			}) => {
			var height = attributes.height;
			var mapID = attributes.mapID; // use 2435 for testing
			var mapName = attributes.mapName;
			const id = `ThoughtMapBlock${ instanceId }`;
			//var content = attributes.content;
			//var alignment = attributes.alignment;
			if (typeof(attributes.mapName) == 'undefined') {
				setAttributes({
					mapName: 'No map chosen'
				});
			}

			console.log(instanceId);
			console.log("----");

			function thoughtBlockContent() {
				//console.log('thoughtBlockContent');
				$content = '<div class="selectMap" id="select' + id + '">test select</div>';

				return $content;
			}

			/*
			function onChangeContent( newContent ) {
			setAttributes( { content: newContent } );
			}
			 */

			function onClickButton() {
				(function ($) {
					//console.log('CLICKED!!!!');
					var wWidth = $(window).width();
					var dWidth = wWidth * 0.8;
					var wHeight = $(window).height();
					var dHeight = wHeight * 0.8;
					if (typeof($("#selectMapDialog").html()) === "undefined") {
						$('body').append('<div id="selectMapDialog"></div>');
					}
					const selectMapDialog = $("#selectMapDialog").dialog({
							resizable: false,
							width: dWidth,
							height: dHeight,
							title: "Select a map",
							containment: 'window',
							//containment: [0,0,$( window ).width(),$( window ).height()-500],
							modal: true,
							dialogClass: "aboveMap addLinkConfirmation",
							open: function (event, ui) {
								$("#selectMapDialog").html('<select id="selectMapList"></select><div class="screenContent">				<span class="fa fa-spinner fa-spin"></span> Loading...</div><iframe src="http://ps.test/?p='+attributes.mapID+'&displayiframe" id="selectMapPreview" scrolling="no" allowtransparency="true"></iframe>');

								$.post({
									type: "post",
									timeout: 20000,
									url: ajax_object.ajax_url,
									data: {
										'action': 'tmap_getUserMaps'
									},
									error: function (textStatus, textStatus2) {
										console.log('Got this error from the server: ');
										console.log(textStatus);
										console.log(textStatus2);
									},
									success: function (MAINresponse) {
										//setAttributes( { mapName: "jquery last" } );
										console.log(MAINresponse);
										console.log(MAINresponse.data.list);
										console.log(Object.keys(MAINresponse.data.list).length);
										if (Object.keys(MAINresponse.data.list).length > 0) {
											Object.keys(MAINresponse.data.list).forEach(function (item) {
												
												var selected = "";
												if(attributes.mapID == item){
													selected = "selected";
												}
												
												$("#selectMapList").append('<option id="selectMap' + item + '" value="' + item + '" '+selected+'>' + MAINresponse.data.list[item].title + '</option>');
												
												
												/*
												$('#selectMap' + item).click(function () {
												setAttributes({
												mapID: item,
												mapName: decodeHtml(MAINresponse.data.list[item].title)
												});
												$("#selectMapDialog").dialog("close");
												});
												 */
											});
											//console.log("%c%s", "color: #55ff55; font-size:30px;","setup changed");
											$('#selectMapList').on('change', function (e) {
												console.log("%c%s", "color: #55ff55; font-size:30px;", "changed");
												console.log($("option:selected", this)[0].value);
												console.log($("option:selected", this).html());
												document.getElementById('selectMapPreview').src = 'http://ps.test/?p='+this.value+'&displayiframe';
												
												
											});
										}
									}
								})
							},
							buttons: {
								"Save": function () {
									setAttributes({
										mapID: $("option:selected", "#selectMapList")[0].value,
										mapName: decodeHtml($("option:selected", "#selectMapList").html())
									});
									$("#selectMapDialog").dialog("close");
								},
								"Cancel": function () {
									$("#selectMapDialog").dialog("close");
								}
							}
						});
				})(jQuery);
			}

			function onChangeAlignment(newAlignment) {
				setAttributes({
					alignment: newAlignment === undefined ? 'none' : newAlignment
				});
			}

			function onChangeResize(event, direction, elt, delta) {
				console.log(delta);
			}

			function selectMapButtonText() {
				if (typeof(attributes.mapID) == 'undefined') {
					return "Select Map";
				} else {
					return "Change Map";
				}
			}

			const pStyle = {
				"margin-top": (height / 2 - 60)
			};

			return (
				 < Fragment >
				 < ResizableBox

				className = {
					classnames(
						'resizeMapBlock block-library-spacer__resize-container',
						(isSelected ? 'is-selected' : []), )
				}
				size = { {
						height,
					}
				}
				minHeight = "130"
					enable = { {
						top: false,
						right: false,
						bottom: true,
						left: false,
						topRight: false,
						bottomRight: false,
						bottomLeft: false,
						topLeft: false,
					}
				}
				//style={'margin-top:'+(height / 2 - 60) + 'px'}
				onResizeStop = {
					(event, direction, elt, delta) => {
						console.log(event);
						console.log(direction);
						console.log(elt);
						console.log(delta);
						setAttributes({
							height: parseInt(height + delta.height, 10),
						});
						toggleSelection(true);
					}
				}
				onResizeStart = {
					() => {
						toggleSelection(false);
					}
				}
				onResize = {
					(event, direction, elt, delta) => {
						var tmpHeight = parseInt(height + delta.height, 10);
						jQuery('.mapBlockDisplay').css('margin-top', (tmpHeight / 2 - 60) + 'px');
					}
				}
				onLoad = {
					(event, direction, elt, delta) => {
						//var tmpHeight = parseInt(height + delta.height, 10);
						jQuery('.mapBlockDisplay').css('margin-top', (height / 2 - 60) + 'px');
					}
				}
				 >
				 < div id = {
					'select' + id
				}
				class = "selectMap" >
					 < div style = {
					pStyle
				}
				class = "mapBlockDisplay" > {
					attributes.mapName
				}
				 < p >
				 < Button isPrimary isLarge onClick = {
					() => onClickButton()
				}
				 > {
				selectMapButtonText()
			}
				 <  / Button >
				 <  / p >
				 <  / div >
				 <  / div >
				 <  / ResizableBox >
				 < InspectorControls >
				 < PanelBody title = {
					__('Thought Map Settings')
				}
				 >
				 < BaseControl label = {
					__('Height in pixels')
				}
				id = {
					id
				}
				 >
				 < input
				type = "number"
					id = {
					id
				}
				onChange = {
					(event) => {
						setAttributes({
							height: parseInt(event.target.value, 10),
						});
					}
				}
				value = {
					height
				}
				min = "130"
					step = "10"
					/>
																						</BaseControl >
					 <  / PanelBody >
					 <  / InspectorControls >
					 <  / Fragment > );
		}),
		save: function (props) {
			return el('div', {
				className: 'gutenberg-examples-align-' + props.attributes.alignment,
				style: {
					height: props.attributes.height + 'px',
				}
			},
				'[tmap_thought id=' + props.attributes.mapID + ']');
			/*
			return el( RichText.Content, {
			tagName: 'div',
			className: 'gutenberg-examples-align-' + props.attributes.alignment,
			value: props.attributes.content,
			style: {
			backgroundColor: '#900',
			color: '#fff',
			padding: '20px',
			height:props.attributes.height+'px',
			}
			} );
			 */
		},
	});
}
	(
		window.wp.blocks,
		window.wp.editor,
		window.wp.i18n,
		window.wp.element,
		window.wp.component));
