<?php

/**
 * Plugin Name: Gutenberg Examples Basic
 * Plugin URI: https://github.com/WordPress/gutenberg-examples
 * Description: This is a plugin demonstrating how to register new blocks for the Gutenberg editor.
 * Version: 1.0.2
 * Author: the Gutenberg Team
 *
 * @package gutenberg-examples
 */

defined( 'ABSPATH' ) || exit;

/**
 * Load all translations for our plugin from the MO file.
 */
//add_action( 'init', 'gutenberg_examples_01_load_textdomain' );

function gutenberg_examples_01_load_textdomain() {
	load_plugin_textdomain( 'gutenberg-examples', false, basename( __DIR__ ) . '/languages' );
}

/**
 * Registers all block assets so that they can be enqueued through Gutenberg in
 * the corresponding context.
 *
 * Passes translations to JavaScript.
 */
function gutenberg_thought_map_block() {
	//log_it('thought init');
	if ( ! function_exists( 'register_block_type' ) ) {
		// Gutenberg is not active.
		return;
	}

	/*
	wp_enqueue_style(
		'jquery-ui-theme-smoothness',
		'//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css',
		array( 'wp-edit-blocks' )
	);
	*/
	
	wp_enqueue_script(
		'thought-map-block',
		plugins_url( 'block.build.js', __FILE__ ),
		array( 'wp-blocks', 'wp-i18n', 'wp-element', 'wp-editor', 'underscore'  ),
		filemtime( plugin_dir_path( __FILE__ ) . 'block.build.js' )
	);
	
	wp_localize_script( 'thought-map-block', 'ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ), 'we_value' => 12345) );
	
	wp_enqueue_style(
		'thought-map-block-editor',
		plugins_url( 'editor.css', __FILE__ ),
		array( 'wp-edit-blocks' ),
		filemtime( plugin_dir_path( __FILE__ ) . 'editor.css' )
	);
	
	register_block_type( 'thoughtmap/map', array(
		'editor_script' => 'thought-map-block',
	) );



}
add_action( 'enqueue_block_assets', 'gutenberg_thought_map_block' );


