<?php /*
 
lemurWP (LemurSettingsPage)
Version: 0.1.2
last update: 20190114

if ( is_admin() ){ // admin actions
	require 'inc/lemurWP/lemurWP.php';
	$LemurSettingsPage = new LemurSettingsPage(array(
	"title" => "Settings page title if you want one",
    "pluginName" => "Media Travel Map",
    "pluginprefix" => "mtm",
	"devMode" => true,
    "settings_group_name" => "mtm-settings-group",
    "settings_page_name" => "mtm_settings_page",
	//"submenu" => "edit.php?post_type=mtmmap",
	"groups" => array(
		"sftp" => array(
			"name" => "Group Name",
			"description" => "enter stuff here",
		),
	),
    "options" => array(
        "option_name_1" => array(
            "name" => "Option",
            "type" => "text",
			"description" => "description text",
			"options" => array(
				//"size" => 100,			 
			),
        ),
        "option_name_2" => array(
            "name" => "Option",
            "type" => "color",
        ),
        "option_name_3" => array(
            "name" => "Option",
            "type" => "checkbox",
        ),
        "option_name_switch" => array(
            "name" => "Option",
            "type" => "switch",
			"textAfter" => "text after box",
			"fieldLink" => "field key to hide/show on switch change",
        ),
        "option_name_4" => array(
            "name" => "Option",
            "type" => "textarea",
			//"cols" => 80,
			//"rows" => 10,
        ),
        "option_name_5" => array(
            "name" => "Option",
            "type" => "dropdown",
			"selections" => array(
				"1" => "One",
				"4" => "Four",
			),
        ),
        "option_info" => array(
            "name" => "Info Name",
            "type" => "info",
			"content" => "This is some info text",
        ),
		"option_checkbox" => array(
			"name" => "checkbox",
			"type" => "checkbox",
			"text" => "text before box",
			"textAfter" => "text after box",
		),
		"option_buttonlink" => array(
			"name" => "Minify Scripts",
			"link" => "/?tmap_minify_scripts",
			"target" => "_BLANK",
			"type" => "buttonlink",
		),
		"option_link" => array(
			"name" => "Minify Scripts",
			"link" => "/?tmap_minify_scripts",
			"target" => "_BLANK",
			"type" => "link",
		),
    ),
	"licenses" => array(
		"visjs" => array(
			"name" => "vis.js",
			"file" =>  plugins_url( 'js/vis-4.21/LICENSE-MIT', __FILE__ ) ,
			"link" => "http://visjs.org/#licenses",
			"logo" => "http://visjs.org/#licenses",
			"github" => "https://github.com/almende/vis",
			"npm" => "https://www.npmjs.com/package/vis",
		),
	)
));
}

*/
if(!class_exists("LemurSettingsPage")):
class LemurSettingsPage
{
    /**
     * Holds the values to be used in the fields callbacks
     */
    private $options;

    /**
     * Start up
     */
    public function __construct($optionsInput)
    {
		$this->options = $optionsInput;
		//print_r($options);
        add_action( 'admin_menu', array( $this, 'add_plugin_page' ) );
        add_action( 'admin_init', array( $this, 'page_init' ) );
        add_action( 'admin_enqueue_scripts', array( $this, 'add_plugin_admin_scripts' ) );
		
		//echo '<br><br>'.__( $this->options["pluginName"]).'<hr><hr>';
    }

    /**
     * Check for LemurWP License Page
     */
    public function LicenseCheck()
    {
		foreach($GLOBALS['submenu']['options-general.php'] as $array) {
			if(in_array('LemurWP',$array)) {
				return true;
			}
		}
		
		return false;
		
    }
	
	/**
     * Options page callback
     */
    private function control_loop($key,$value)
    {
		//echo $key;
		//if(isset($override)){
			//$getoption = $override;
		//}else{
			$getoption = get_option($key);
		//}
		
		switch ($value['type']) {
		   case "text":
				 echo '<input type="text" ';
				 if (array_key_exists("options",$value)){
					 foreach ($value["options"] as $keyO => $valO) {
						echo $keyO.'="'.$valO.'" ';
					 }
				 }
				 echo 'name="'.$key.'" value="'.esc_attr( $getoption ).'" /> ';
				 if (array_key_exists("textAfter",$value)){
					echo $value["textAfter"]." ";
				 }
				 echo '';
				 break;
		   case "color":
				 echo '<input class="color-field" type="text" ';
				 if (array_key_exists("options",$value)){
					 foreach ($value["options"] as $keyO => $valO) {
						echo $keyO.'="'.$valO.'" ';
					 }
				 }
				 echo' name="'.$key.'" value="'.esc_attr( $getoption ).'" /> ';
				 if (array_key_exists("textAfter",$value)){
					echo $value["textAfter"]." ";
				 }
				 echo '';
				 break;
		   case "checkbox":
				 echo '';
				 if (array_key_exists("text",$value)){
					echo $value["text"]." ";
				 }
				 echo '<input type="checkbox" ';
				 
				 if (array_key_exists("options",$value)){
					 foreach ($value["options"] as $keyO => $valO) {
						echo $keyO.'="'.$valO.'" ';
					 }
				 }
				 echo ' name="'.$key.'" '.checked( esc_attr( $getoption ), 1 ).' value="1" /> ';
				 if (array_key_exists("textAfter",$value)){
					echo $value["textAfter"]." ";
				 }
				 echo '';
				 break;
		   case "switch":
				 echo '';
				 if (array_key_exists("text",$value)){
					echo $value["text"]." ";
				 }
				 echo '<input type="checkbox" ';
				 
				 if (array_key_exists("options",$value)){
					 foreach ($value["options"] as $keyO => $valO) {
						echo $keyO.'="'.$valO.'" ';
					 }
				 }
				 echo ' class="lc_switch" ';
				 
				 if (array_key_exists("fieldLink",$value)){
					echo 'fieldLink='.$this->options['pluginprefix'].'_'.$value["fieldLink"]." ";
				 }
				 
				 echo ' name="'.$key.'" '.checked( esc_attr( $getoption ), 1 ).' value="1" /> ';
				 if (array_key_exists("textAfter",$value)){
					echo $value["textAfter"]." ";
				 }
				 echo '';
				 break;
		   case "textarea":
				$tmpCols=40;
				$tmpRows=5;
				if (array_key_exists("cols",$value)){
					$tmpCols=$value['cols'];
				}
				if (array_key_exists("rows",$value)){
					$tmpRows=$value['rows'];
				}
				echo '<textarea cols="'.$tmpCols.'" rows="'.$tmpRows.'" name="'.$key.'">'. esc_attr( $getoption).'</textarea> ';
				 if (array_key_exists("textAfter",$value)){
					echo $value["textAfter"]." ";
				 }
				 echo '';
				 break;
		   case "dropdown":
				 echo '<select ';
				 if (array_key_exists("options",$value)){
					 foreach ($value["options"] as $keyO => $valO) {
						echo $keyO.'="'.$valO.'" ';
					 }
				 }
				 echo 'name="'.$key.'">';
				 foreach ($value["selections"] as $keyO => $nameO) {
					echo '<option value="'.$keyO.'" '. selected( esc_attr( $getoption), $keyO ).'>'.$nameO.'</option>';
				 };
				echo '</select> ';
				 if (array_key_exists("textAfter",$value)){
					echo $value["textAfter"]." ";
				 }
				 echo '';
				break;
		   case "sortable":
				 echo '
				 <ul target="'.$key.'" class="sortable">';
				 if($getoption!=""){
					//echo $getoption;
					$order = json_decode($getoption, true);
					//print_r($order);
					array_flip($order);
					uksort($value["selections"], function($key1, $key2) use ($order) {
						return ((array_search($key1, $order) > array_search($key2, $order)) ? 1 : -1);
					});
				 }
				 foreach ($value["selections"] as $keyO => $nameO) {
					echo '
					<li id="'.$keyO.'" class="ui-state-default" value="'.$keyO.'"  ><span class="ui-icon ui-icon-arrowthick-2-n-s"></span>'.$nameO.'</li>';
					
				 };
				echo '</ul><input type="hidden" id="'.$key.'" name="'.$key.'" value=\''.$getoption.'\' /> ';
				 if (array_key_exists("textAfter",$value)){
					echo $value["textAfter"]." ";
				 }
				 echo '';
				break;
		   case "info":
				 if (array_key_exists("content",$value)){
					 echo ''.$value["content"].'';
				 }
				 break;
		   case "buttonlink":
				
				if (array_key_exists("link",$value)){
					 $link = $value["link"];
				}else if (array_key_exists("href",$value)){
					 $link = $value["href"];
				}
				
				echo '<a class="button customize load-customize hide-if-no-customize" ';
				
				if (array_key_exists("target",$value)){
					echo 'target="'.$value["target"].'"';
				}
				
				echo 'href="'.$link.'">';
		   
				if (array_key_exists("name",$value)){
					echo $value["name"];
				}
				echo '</a> ';
				if (array_key_exists("textAfter",$value)){
					echo $value["textAfter"]." ";
				}
				echo '';
				break;
		   case "multi":
				
				if (!array_key_exists("items",$value)){
					break;
				}
				
				?>
				
				<style type='text/css'>
					.rowTemplate{
						display:none;
					}
				</style>
				
				<?php
				
				//echo '<pre>'.print_r($value,true).'</pre>';
				
				echo '<input class="" type="text" style="display:none;" id="'.$key.'" name="'.$key.'" value=\''.$getoption.'\' />';
				
				//wp_json_encode
				$currentValue = array();
				if($getoption){
					$currentValue = json_decode($getoption);
				}
				
				//echo '<pre>'.print_r($value["items"],true).'</pre>';
				echo '<table  class="multiOption" key="'.$key.'"><tr>';
					/*
					foreach ($value["items"] as $subkey => $subvalue) {
						
						echo '<th>'.$subvalue['name'];
						if (isset($value['description'])){
							echo '<p class="description">'.$subvalue['description'].'</p>';
						}
						echo '</th>';
					}
					*/
				echo '</tr><tr class="rowTemplate">';
					echo '<td>';
					foreach ($value["items"] as $subkey => $subvalue) {
						
						echo '<div';
						if(array_key_exists('newline',$subvalue) ){
							echo ' class="clear"';
						}
						echo'><span class="fieldTitle">'.$subvalue['name'].'</span>';
						if (isset($value['description'])){
							echo '<p class="description">'.$subvalue['description'].'</p>';
						}
						
						self::control_loop($subkey,$subvalue);
						
						echo '</div>';
						
						
					}
					echo '</td>';
					echo '<td><span class="dashicons dashicons-trash del"></span></td>';
				echo '</tr><tfoot>';
				
				echo '<td><button type="button" class="add">Add</button></td>';
				
				echo '</tfoot></table>';
				
				
				break;
		   case "link":
				
				if (array_key_exists("link",$value)){
					 $link = $value["link"];
				}else if (array_key_exists("href",$value)){
					 $link = $value["href"];
				}
				
				echo '<a class="" ';
				
				if (array_key_exists("target",$value)){
					echo 'target="'.$value["target"].'"';
				}
				
				echo 'href="'.$link.'">';
		   
				if (array_key_exists("name",$value)){
					echo $value["name"].' ';
				}
				echo '( '.$link.' )</a> ';
				if (array_key_exists("textAfter",$value)){
					echo $value["textAfter"]." ";
				}
				echo '';
				break;
		}
		//return;
	}

    /**
     * Add options page
     */
    public function add_plugin_page()
    {
        
		if (array_key_exists("submenu",$this->options)){
			// This page will be under another page
			add_submenu_page(
				$this->options['submenu'],
				$this->options["pluginName"].' Settings',
				'Settings',
				'manage_options',
				$this->options["settings_group_name"],
				array( $this, 'create_admin_page' )
			);
			
			if (isset($this->options["licenses"])){
				add_submenu_page(
					$this->options['submenu'],
					$this->options["pluginName"].' Licenses',
					'Licenses',
					'manage_options',
					$this->options["settings_group_name"].'licences',
					array( $this, 'create_license_page' )
				);
			}
		
		}else{
		
			// This page will be under "Settings"
			add_options_page(
				$this->options["pluginName"].' Settings',
				$this->options["pluginName"],
				'manage_options',
				$this->options["settings_group_name"],
				array( $this, 'create_admin_page' )
			);
		
		};
		
		if ( !$this->LicenseCheck() ){
			add_options_page(
				'LemurWP Settings',
				'LemurWP',
				'manage_options',
				'LemurWP',
				array( $this, 'create_LemurWP_page' )
			);
		}
		
		
		
    }

    /**
     * Add Admin Scripts
     */
    public function add_plugin_admin_scripts()
    {
        // Add the color picker css file       
        wp_enqueue_style( 'wp-color-picker' ); 
		// Include our custom jQuery file with WordPress Color Picker dependency
        //wp_enqueue_script( $this->options["pluginprefix"].'_admin_script', plugins_url( 'js/admin-scripts.js', __FILE__ ), array( 'wp-color-picker' ), false, true ); 
        wp_enqueue_script( 'lemurWP_admin_script', plugins_url( 'js/admin-scripts.js', __FILE__ ), array( 'wp-color-picker','lemurWP_lc_switch_script' ), false, true ); 
        
		wp_enqueue_script( 'lemurWP_lc_switch_script', plugins_url( 'js/LC-switch/lc_switch.js', __FILE__ ), array( 'jquery' ), false ); 
        
		wp_enqueue_style( 'lemurWP_lc_switch_style', plugins_url( 'js/LC-switch/lc_switch.css', __FILE__ )); 
		
		wp_enqueue_style( 'lemurWP_style', plugins_url( 'css/lemurWP.css', __FILE__ )); 
		
    }

	
    /**
     * Options page callback
     */
    public function create_admin_page()
    {
		
		foreach ($this->options["options"] as $key => $value) {
			$this->options["options"][$key]["key"] = $key;
			if (!array_key_exists("group",$value)){
				$this->options["options"][$key]["group"] = "0";
			}
		}
		
		$optionsArray = $this->options["options"];
		
		
		
		if (isset($this->options["groups"])){
			$order = array();
			foreach ($this->options["groups"] as $key => $value) {
				$order[] = $key;
			}
			//$ordered_array = array_merge(array_flip($order), $user);
			array_flip($order);
			usort($this->options["options"], function($key1, $key2) use ($order) {
				return ((array_search($key1['group'], $order) > array_search($key2['group'], $order)) ? 1 : -1);
			});
			//echo "<pre>";
			//print_r($order);
			//echo "</pre>";
		}else{
			usort($this->options["options"], function($a, $b) {
				return $a['group'] <=> $b['group'];
			});
		}
		
		//natsort($optionsArray);
		//echo "<pre>";
		//print_r($optionsArray);
		//echo "</pre>";
		//log_it(print_r($optionsArray,true));
		
		if (isset($this->options["title"])){
			echo "<h1>". $this->options["title"]."</h1>";
		}else if (isset($this->options["pluginName"])){
			echo "<h1>". $this->options["pluginName"]." Settings</h1>";
		}
		$currentGroup = "0";
	?><div class="wrap">
	<form method="post" action="options.php">
    <?php settings_fields( $this->options["settings_group_name"] ); ?>
    <?php do_settings_sections( $this->options["settings_group_name"] ); ?>
    <table class="form-table">
        <tr valign="top">
        <?php
		
		foreach ($this->options["options"] as $key => $value) {
			//$key = $this->options['pluginprefix'].'_'.$key;
			
			if($currentGroup != $value['group']){
				$currentGroup = $value['group'];
				echo '<tr valign="top"><td colspan="2"><hr></td></tr>';
				if (isset($this->options["groups"][$value["group"]])){
					if (isset($this->options["groups"][$value["group"]]['name']) || isset($this->options["groups"][$value["group"]]['description'])){
						echo '
						<tr valign="top">
						<th scope="row" >
						</th>
						<td>';
						
						if (isset($this->options["groups"][$value["group"]]['name'])){
							echo '<h3>'.$this->options["groups"][$value["group"]]['name'].'</h3>';
						}
						if (isset($this->options["groups"][$value["group"]]['description'])){
							echo $this->options["groups"][$value["group"]]['description'];
						}
						echo'</td>
						</tr>
						';
					}
				}
				
			}
			
			$key = $this->options['pluginprefix'].'_'.$value['key'];
			echo '<tr valign="top" class="'.$key.'_tr">
				  <th scope="row">';
				  if (isset($value['nameWrap'])){
					  if(is_array($value['nameWrap'])){
						  $tmpCSS = '';
						  if (array_key_exists("style",$value['nameWrap'])){
							  $tmpCSS = ' style="'.$value['nameWrap']['style'].'" ';
						  }
						  
						  if (array_key_exists("before",$value['nameWrap']) && array_key_exists("before",$value['after'])){
							  echo '<'.$value['nameWrap']['before'].$tmpCSS.'>'.$value['name'].'</'.$value['nameWrap']['after'].'>';
						  }else if (array_key_exists("wrap",$value['nameWrap']) ){
							   echo '<'.$value['nameWrap']['wrap'].$tmpCSS.'>'.$value['name'].'</'.$value['nameWrap']['wrap'].'>';
						  }
						  
					  }else{
						  echo '<'.$value['nameWrap'].'>'.$value['name'].'</'.$value['nameWrap'].'>';
					  }
				  }else{
					echo $value['name'];
				  }
				  
				  if ($value['type']!="info" && $this->options["devMode"] == true){
					echo '<br><span id="'.$key.'_span" class="copyable" style="font-size:0.8em;font-weight:normal">( '.$key.' )</span>';
				  }
				  echo '</th>';
			
			
			echo '<td>';
			self::control_loop($key,$value);
			if (isset($value['description'])){
				echo '<p class="description">'.$value['description'].'</p>';
			}
			echo '</td></tr>';
		}
		
		
		?>

      </table>
    
    <?php submit_button(); ?>
	</form>
	</div>
	<?php
	
	if (!array_key_exists("submenu",$this->options) && isset($this->options["licenses"])){
			echo '<hr>';
			$this->create_license_page();
		}
	
    }

	

    /**
     * Licenses page callback
     */
    public function create_license_page()
    {
		

		$licensesArray = $this->options["licenses"];
		

		
		//natsort($optionsArray);
		//echo "<pre>";
		//print_r($optionsArray);
		//echo "</pre>";
		//log_it(print_r($optionsArray,true));
		

	?><div class="wrap">
	
    <table class="form-table">
        <tr valign="top">
				  <th scope="row" colspan=2><?php echo "<h1>". $this->options["pluginName"]." Open Source Licenses</h1>"; ?></th></tr>
        <?php
		
		foreach ($this->options["licenses"] as $key => $value) {
			//$key = $this->options['pluginprefix'].'_'.$key;
			
			$key = $this->options['pluginprefix'].'_'.$value['key'];
			echo '<tr valign="top">
				  <th scope="row"><h1 class="licenceTitle">';
				  $tmpName = '';
				  
				if (isset($value['logo'])){
					$tmpName .=  '<img class="logoIcon" src="'.$value['logo'].'"><br>';
				}
				if (isset($value['lightlogo'])){
					$tmpName .=  '<img class="logoIcon light" src="'.$value['lightlogo'].'"><br>';
				}
				if (isset($value['name'])){
					$tmpName .=  $value['name'];
				}
				  
					if (isset($value['link'])){
						echo '<a target="_BLANK" href="'.$value['link'].'">'.$tmpName.'</a>';
					}else{
						echo $tmpName;
					}
				  echo '</h1>';
/*
				  if (isset($value['github']) || isset($value['npm'])){
					  echo 'View on:';
				  }
				  */
				if (isset($value['github'])){
					echo '<br><a target="_BLANK" href="'.$value['github'].'"><img class="licenceIcon" src="'.plugins_url( 'img/GitHub-Mark-32px.png', __FILE__ ).'"><img class="licenceIcon" src="'.plugins_url( 'img/GitHub_Logo.png', __FILE__ ).'"></a>';
				}
				if (isset($value['npm'])){
					echo '<br><a target="_BLANK" href="'.$value['npm'].'"><img class="licenceIcon" src="'.plugins_url( 'img/npm-logo-red.png', __FILE__ ).'"></a>';
				}
				  echo '</th>';
			
			
			
			echo '<td class="expandable">';
				if (isset($value['header'])){
					if (isset($value['headerlink'])){
						echo '<h2><a target="_BLANK" href="'.$value['headerlink'].'">'.$value['header'].'</a></h2>';
					}else{
						echo '<h2>'.$value['header'].'</h2>';
					}
				}
				if (isset($value['file'])){
					echo '<pre>'.file_get_contents($value['file']).'</pre>';
				}
				if (isset($value['text'])){
					echo '<pre>'.$value['text'].'</pre>';
				}
			echo '</td></tr><tr><td colspan=2><hr></td></tr>';
		}
		
		?>

      </table>

	</div>
	<?php
    }

    /**
     * Options page callback
     */
    public function create_LemurWP_page()
    {
		
		
	?><div class="wrap">
	<h1>LemurWP</h1>
	
    <table class="form-table">
		<tr><td colspan="2"><h1 style="text-align:center;">Open Source Licenses</h1></td></tr>
		<tr valign="top">
			<th scope="row" >
				<h2><a target="_BLANK" href="https://github.com/LCweb-ita/LC-switch">lc_switch jQuery Plugin</a></h2>
			</th>
			<td>
				<pre>
					<?php echo file_get_contents( plugins_url( 'js/LC-switch/LICENSE', __FILE__ ) ); ?>
				</pre>
			</td>
		</tr>
	</table>
	</div>
	<?php
    }

    /**
     * Register and add settings
     */
    public function page_init()
    {   
	
		foreach ($this->options["options"] as $key => $value) {
			//echo $key.' - ';
			register_setting( $this->options["settings_group_name"], $this->options['pluginprefix'].'_'.$key );
		}
	
    }

    
}
endif;


if(!class_exists("LemurHeartbeat")):
class LemurHeartbeat
{
    /**
     * Holds the values to be used in the fields callbacks
     */
    private $options;

    /**
     * Start up
     */
    public function __construct($optionsInput)
    {
		$this->options = $optionsInput;
		//print_r($options);
		//error_log( "added leamurBeat" );
		// Add filter to receive hook, and specify we need 2 parameters.
		//add_filter( 'heartbeat_received', array( $this, 'lemur_receive_heartbeat' ), 10, 2 );
		
		if($this->options["heart_overide"] == true){
			add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_heartbeat' ) );
		}
		
		//wp_enqueue_script( 'heartbeat', "/wp-includes/js/heartbeat$suffix.js", array( 'jquery', 'wp-hooks' ), false, 1 );
		
		//echo '<br><br>'.__( $this->options["pluginName"]).'<hr><hr>';
    }

	public function log_it( $message ) {
		if( WP_DEBUG === true ){
			if( is_array( $message ) || is_object( $message ) ){
				error_log( print_r( $message, true ) );
			} else {
				error_log( $message );
			}
		}
	}
	
    /**
     * re enqueue heartbeat
     */
    public function enqueue_heartbeat( )
    {
		$suffix     = wp_scripts_get_suffix();
        wp_enqueue_script( 'heartbeat', "/wp-includes/js/heartbeat.js", array( 'jquery', 'wp-hooks' ), false, 1 );
		//error_log( "added heartbeat" );
		//$this->log_it(get_option('heartbeat_location'));
		return;
		
    }

    /**
     * Deal with heartbeat
     */
    public function lemur_receive_heartbeat( $response, $data )
    {
        $this->log_it('--heartbeat_received--' );
		$this->log_it( $response );
		$this->log_it( $data );
		$response['lemurTest'] = "I'm a TEST!";
		return $response;
		
    }

}
endif;


?>