const screenfull = require('screenfull');

(function ($) {
	
	
	
	window.tmap.thoughtMode = true;
	jQuery(document).ready(function ($) {
		if (window.tmap.visOptions.fourOfour) { //404 error check
			return;
		}
		
		if(ajax_object_explore.iframe){
			$('#glt-translate-trigger').hide();
			$('#ps-bookmarks-drawer').hide();
			//$('#explore_loadingScreen').fadeIn(500);
			$('body').fadeIn(500);
		}
		
		/* ========================================= */
		/* IDEA ONLY FUNCTIONS */
		/* ========================================= */

		//console.log('AJAX OBJECT');
		//console.log(ajax_object);


		$('#mynetwork canvas').attr("id", "mynetworkCanvas");

		var currentData = '';
		var undoData = '';

		window.tmap.visOptions.nodesLocked.shadow = false;

		function addConnections(elem, index) {
			// need to replace this with a tree of the network, then get child direct children of the element
			elem.connections = window.tmap.network.getConnectedNodes(elem.id);
		}

		function screenfullChangeListener() {
			//return;
			console.log("screenfullChangeListener");
			if (!screenfull.isFullscreen) {
				$("#mynetwork").removeClass('fullscreen').promise().done(function () {
					fullscreenSync();
				});
				screenfull.off('change', screenfullChangeListener);
			}
			fullscreenSync();
		}

		function fullscreenSync() {
			console.log("fullscreenSync");
			if ($("#mynetwork").hasClass("fullscreen")) {
				if (!ajax_object_explore.iframe) {
				$('#fullscreen_map_button div.vis-label').html('\
					<span class="fa fa-times-circle"> Exit</span>\
					');
				};
				$('#explore_map_overlay').hide();
				$('#glt-translate-trigger').hide();
				$('#ps-bookmarks-drawer').hide();
				//$('#mynetwork').removeClass('displayInline');
			} else {
				$('#fullscreen_map_button div.vis-label').html('');
				$('#explore_map_overlay').show();
				$('#glt-translate-trigger').show();
				$('#ps-bookmarks-drawer').show();
				//$('#mynetwork').addClass('displayInline');

			}
			setTimeout(function () {
				window.tmap.network.fit();
				window.tmap.network.redraw();
				window.tmap.network.fit();
			}, 500);

		}

		function toggleFullscreen() {
			console.log("toggleFullscreen");
			if (screenfull.enabled) {
				if (screenfull.isFullscreen) {
					screenfull.off('change', screenfullChangeListener);
					screenfull.exit().then(function () {
						$("#mynetwork").removeClass('fullscreen').promise().done(function () {
							fullscreenSync();
						});
					});

				} else {
					screenfull.request($('body')[0]).then(function () {
						$("#mynetwork").addClass('fullscreen').promise().done(function () {
							fullscreenSync();
						});
						screenfull.on('change', screenfullChangeListener);
					});
				}
			} else {
				$("#mynetwork").toggleClass('fullscreen').promise().done(function () {
					fullscreenSync();
				});

			}

		}

		function setupFullscreen() {
			console.log("setupFullscreen");
			//if (screenfull.enabled && ajax_object_explore.nogoshortcode) {
			$('div.vis-network div.vis-navigation').append('\
				<div id="explore_map_overlay">\
				<div class="screenContent">\
				click to view\
				</div>\
				</div>\
				');

			$('div.vis-network div.vis-navigation').append('\
				<div id="fullscreen_map_button" class="vis-button vis-up help" style="touch-action: pan-y; user-select: none; -webkit-user-drag: none; -webkit-tap-highlight-color: rgba(0, 0, 0, 0);">\
				<div class="vis-label">\
				</div>\
				</div>\
				');

			$('#fullscreen_map_button').click(function () {
				toggleFullscreen();
			});

			$('#explore_map_overlay').click(function () {
				toggleFullscreen();
			});
			
			if (ajax_object_explore.startfull) {
				//console.log("%c%s", "color: #ff5555; font-size:30px;","startfull");
				if (!$("#mynetwork").hasClass("fullscreen")) {
					//toggleFullscreen();
					$("#mynetwork").addClass('fullscreen').promise().done(function () {
						fullscreenSync();
					});
					fullscreenSync();
				}
			}
			
			if (ajax_object_explore.iframe) {
				//console.log("%c%s", "color: #ff5555; font-size:30px;","iframe");
				$("#mynetwork").addClass('iframe');
				if (!$("#mynetwork").hasClass("fullscreen")) {
					//toggleFullscreen();
					$("#mynetwork").addClass('fullscreen').promise().done(function () {
						fullscreenSync();
					});
					fullscreenSync();
				}
			}
			
			/*
			screenfull.onchange(function () {
			if (screenfull.isFullscreen) {
			$('#fullscreen_map_button div.vis-label').html('\
			<span class="fa fa-times-circle"> Exit</span>\
			');
			$('#explore_map_overlay').hide();
			$('#mynetwork').removeClass('displayInline');
			} else {
			$('#fullscreen_map_button div.vis-label').html('');
			$('#explore_map_overlay').show();
			$('#mynetwork').addClass('displayInline');

			}

			setTimeout(function () {
			window.tmap.network.fit();
			window.tmap.network.redraw();
			window.tmap.network.fit();
			}, 500);

			});

			 */
			//};
		}

		window.tmap.thoughtmap = function () {
			/*
			if(showEditButton == true){
			$('div.vis-network div.vis-navigation').append('\
			<div id="edit_map_button" class="vis-button vis-up edit" style="touch-action: pan-y; user-select: none; -webkit-user-drag: none; -webkit-tap-highlight-color: rgba(0, 0, 0, 0);">\
			<div class="vis-label">\
			Edit\
			</div>\
			</div>\
			');

			$('#edit_map_button').on("click", function () {
			window.location = "?editthought=yes";
			});
			}
			 */

			var inputValue = $("#mapData").html();
			var inputOptionsValue = $("#mapOptions").html();
			//console.log(inputValue);
			if (inputValue == "" && inputOptionsValue == "") {
				console.log("Using default thought options.");
				inputOptions = window.tmap.visOptions.thoughtInputOptions;
			} else {

				//console.log(inputValue);
				if (inputValue !== "			" && inputValue !== "") {
					console.log("importing data");
					var inputData = JSON.parse(inputValue);
					nodes.clear();
					edges.clear();
					nodes.add(inputData.nodes);
					edges.add(inputData.edges);

					nodes.forEach(function (node) {
						//console.log(node);
						var deleteFlag = false;
						if (node.type == "tag") {
							node.label = decodeURIComponent(node.label);
						}

						if (typeof node.title != 'undefined') {
							node.title = unescape(node.title);
							if (node.title == "undefined") {
								delete node.title;
								deleteFlag = true;
							}
						}

						if (typeof node.videoEmbed != 'undefined' && node.videoEmbed != '') {
							//console.log(node.popupHTML);
							node.videoEmbed = decodeURI(node.videoEmbed);
							//node.popupHTML = decodeURI(node.popupHTML);
							nodes.update(node);
						};

						if (typeof node.popupHTML != 'undefined' && node.popupHTML != '') {
							//console.log(node.popupHTML);
							node.popupHTML = unescape(node.popupHTML);
						}
						//node.popupHTML = decodeURI(node.popupHTML);
						if (deleteFlag) {
							nodes.remove(node);
							nodes.update(node);
						} else {
							nodes.update(node);
						}
					});

					edges.forEach(function (edge) {
						//console.log(edge);
						var tempEdge = window.clone(edge);
						window.deepAssign(edge, window.tmap.visOptions.newedge, tempEdge);
						edges.update(edge);
					});

					var inputData = {
						nodes: nodes,
						edges: edges
					}

					inputDataCurrent = inputData;

					window.tmap.network.setData(inputData);
				}

				var inputOptions = JSON.parse(inputOptionsValue);
				window.tmap.network.storePositions();
				//console.log(exportNetwork());
				currentData = exportNetwork();
				//console.log("network data being saved:");
				//console.log(currentData);
				var inputViewValue = $("#mapView").html();
				//console.log(inputViewValue);

				if (ajax_object_explore.displayInline) {
					setTimeout(function () {
						window.tmap.network.fit();
					}, 0);
				} else if (inputViewValue !== "			") {
					try {
						var inputView = JSON.parse(inputViewValue);

						var outputView = {
							position: inputView.position,
							scale: inputView.scale,
							/*
							offset: {
							x: 0,
							y: 0
							},
							 */
							animation: false
						}
						//console.log(outputView);
						console.log("moving");

						window.tmap.outputView = outputView;

						/*
						outputView.animation = { // -------------------> can be a boolean too!
						duration: 250,
						easingFunction: "easeInOutQuart"
						}
						 */

						setTimeout(function () {
							window.tmap.network.moveTo(outputView);
							//window.tmap.network.moveTo(inputView);
							setTimeout(function () {
								$('#explore_loadingScreen').fadeOut(500);
							}, 500);
						}, 0);

					} catch (err) {

						setTimeout(function () {
							window.tmap.network.fit({
								//animation: true,
								//animation: { // -------------------> can be a boolean too!
								//	duration: 250,
								//	easingFunction: "easeInOutQuart"
								//}
							});
							setTimeout(function () {
								$('#explore_loadingScreen').fadeOut(500);
							}, 500);
						}, 0);

					}

				} else {
					setTimeout(function () {
						window.tmap.network.fit({
							//animation: true,
							animation: { // -------------------> can be a boolean too!
								duration: 250,
								easingFunction: "easeInOutQuart"
							}
						});
					}, 0);
				};
				//window.tmap.network.startSimulation();
				//console.log(window.tmap.network.getScale());
				//console.log(window.tmap.network.getViewPosition());

				//console.log("trying to go ADMIN");
				//window.tmap.startNetwork();

			}
			window.tmap.network.off('stabilized');

			//$('#mynetwork').on("dragover", allowDrop(event));
			//$('#mynetwork').on("drop", drop(event));

			var tmplocales = {
				en: {
					edit: 'Edit',
					del: 'Delete selected',
					back: 'Back',
					addNode: 'Add Node',
					addEdge: 'Add Connection',
					editNode: 'Edit Node',
					editEdge: 'Edit Edge',
					addDescription: 'Click in an empty space to place a new node.',
					edgeDescription: 'Click on a post and drag the edge to a tag to connect them.',
					editEdgeDescription: 'Click on the control points and drag them to a node to connect to it.',
					createEdgeError: 'Cannot link edges to a cluster.',
					deleteClusterError: 'Clusters cannot be deleted.',
					editClusterError: 'Clusters cannot be edited.'
				}
			}

			var newClick = function (params) {
				//console.log("---NEWCLICK---");
			}

			if (typeof(inputOptions.interaction.dragView) == "undefined") {
				inputOptions.interaction.dragView = true;
			}
			if (typeof(inputOptions.interaction.hover) == "undefined") {
				inputOptions.interaction.hover = false;
			}
			if (typeof(inputOptions.interaction.navigationButtons) == "undefined") {
				inputOptions.interaction.navigationButtons = false;
			}
			if (typeof(inputOptions.interaction.zoomView) == "undefined") {
				inputOptions.interaction.zoomView = true;
			}

			window.tmap.network.setOptions({
				interaction: {
					/*
					dragNodes: false,
					selectable: false,
					dragView: inputOptions.interaction.dragView,
					hover: inputOptions.interaction.hover,
					navigationButtons: inputOptions.interaction.navigationButtons,
					zoomView: inputOptions.interaction.zoomView,
					 */
					dragView: true,
					keyboard: true,
					dragNodes: true,
					selectable: true,
					navigationButtons: false,
					zoomView: true
				},
				//physics:false,
				configure: {
					enabled: true,
					filter: 'interaction',
					container: document.getElementById("thoughtOptions"),
					showButton: false
				},
				locales: tmplocales,
			});
			if (ajax_object_explore.displayInline) {
				//console.log("%c%s", "color: #55ff55; font-size:30px;","ajax_object_explore.displayInline");
				$('#explore_loadingScreen').css("display", "none");
				window.tmap.network.setOptions({
					//clickToUse: true,
					interaction: {
						//dragView: false,
						keyboard: false,
						dragNodes: false,
						selectable: false,
						navigationButtons: true,
						zoomView: false
					},
				});
				if (ajax_object_explore.nogoshortcode) {
					//console.log("%c%s", "color: #5555ff; font-size:30px;","nogoshortcode");
					setupFullscreen();
				}
			}
			if (ajax_object_explore.iframe) {
					//console.log("%c%s", "color: #5555ff; font-size:30px;","iframe");
					$("#mynetwork").addClass('fullscreen');
					$("#mynetwork").addClass('iframe');
					$('body').show();
					//setupFullscreen();
				}

		}

		//console.log("trying to go");
		//window.tmap.startNetwork();


		if (typeof $('#renderInline').html() != 'undefined') {
			//console.log("adding div");
			$('#explore_loadingScreen').css("display", "none");
			//$('#mynetwork').css("display","none");
		}

		window.tmap.thoughtmap();

	});
})(jQuery);
