<?php
defined( 'ABSPATH' ) || exit;
/** FYI -- to get shortcodes and embeds to work over AJAX:
===================================*/

	/** \WP_Post $post */
	//$post = get_post();

	/** @var \WP_Embed $wp_embed */

	//$wp_embed->post_ID = $post->ID;

	// [embed] shortcode
	//$wp_embed->run_shortcode( $post->post_content );

	// plain links on their own line
	//$wp_embed->autoembed( $post->post_content );

	// Enable shortcodes
	//do_shortcode( $post->post_content );


/*
===================================*/


if(!function_exists('log_it')){
 function log_it( $message ) {
   if( WP_DEBUG === true ){
     if( is_array( $message ) || is_object( $message ) ){
       error_log( print_r( $message, true ) );
     } else {
       error_log( $message );
     }
   }
 }
}



add_action( 'wp_ajax_tmap_check_thought_lock', 'tmap_check_thought_lock_callback' );
add_action( 'wp_ajax_nopriv_tmap_check_thought_lock', 'tmap_check_thought_lock_callback' );

function tmap_check_thought_lock_callback() {
	$output = [];
	
	if(!is_user_logged_in()){
		$output['error'] =  "You do not have permission to do this.";
		wp_send_json_error($output);
		wp_die();
	}
	
	if(isset($_POST['mapID']) && $_POST['mapID'] != '' ){
		$mapID = $_POST['mapID'];
	}else{
		$output['error'] =  "mapID must be defined";
		wp_send_json_error($output);
		wp_die();
	}
	
	$output['modified'] = get_the_modified_time( "U" , $mapID );
	
	$output['lock'] = wp_check_post_lock($mapID);
	//log_it(wp_check_post_lock($mapID));
	if(isset($output['error']) && $output['error'] != ""){
		wp_send_json_error($output);
	}else{
		wp_send_json_success($output);
	}
	wp_die();
	
}


add_action( 'wp_ajax_tmap_set_lock', 'tmap_set_lock_callback' );
add_action( 'wp_ajax_nopriv_tmap_set_lock', 'tmap_set_lock_callback' );

function tmap_set_lock_callback() {
	$output = [];
	//$die = true;
	//log_it("going");
	if(!is_user_logged_in()){
		$output['error'] =  "You do not have permission to do this.";
		wp_send_json_error($output);
		wp_die();
	}
	
	if(isset($_POST['mapID']) && $_POST['mapID'] != '' ){
		$mapID = $_POST['mapID'];
	}else{
		$output['error'] =  "mapID must be defined";
		wp_send_json_error($output);
		wp_die();
	}
	
	if(isset($_POST['set']) && $_POST['set'] != '' ){
		$action = $_POST['set'];
	}else{
		$output['error'] =  "set must be defined";
		wp_send_json_error($output);
		wp_die();
	}
	
	$current_user = wp_get_current_user();
	
	$post = get_post($mapID);
	
	
	if( $current_user->ID == $post->post_author || current_user_can("edit_thought",$mapID) || current_user_can("edit_thought_".$mapID) || current_user_can("edit_others_thoughts_NVM")){
		$die = false;
	}else{
		$output['error'] =  "You do not have permission to do this.";
		wp_send_json_error($output);
		wp_die();
	}
	
	
	
	switch ($action) {
		case "lock":
			if(wp_check_post_lock($mapID)){
				$output['error'] =  "thought already locked by another user";
			}else{
				wp_set_post_lock($mapID);
				$output['message'] =  "Locked";
			}
			break;
		case "unlock":
			if(wp_check_post_lock($mapID)){
				$output['error'] =  "thought already locked by another user";
			}else{
				delete_post_meta( $mapID, '_edit_lock');
				$output['message'] =  "UnLocked";
			}
			break;
		default:
			$output['error'] =  "unknown action";
			break;
	}
	
	//log_it(get_post_meta($mapID));
	//wp_check_post_lock_window
	
	$output['lock'] = wp_check_post_lock($mapID);
	
	if(isset($output['error']) && $output['error'] != ""){
		wp_send_json_error($output);
	}else{
		wp_send_json_success($output);
	}
	wp_die();
	
}



add_action( 'wp_ajax_tmap_get_video_embed', 'tmap_get_video_embed_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_video_embed', 'tmap_get_video_embed_callback' );

function tmap_get_video_embed_callback() {
	global $wp_embed;
	
	//--log-it--
	
	if(isset($_POST['url']) and !empty($_POST['url'])){
			//echo do_shortcode( '[embed]'.$_POST['url'].'[/embed]' );
		$url = $_POST['url'];
		$tmpargs = array();
		
		if(isset($_POST['height']) && $_POST['height'] != '' ){
			$tmpargs['height'] = $_POST['height'];
		}
		
		if(isset($_POST['width']) && $_POST['width'] != '' ){
			$tmpargs['width'] = $_POST['width'];
		}
		
		if(isset($_POST['autoplay']) && $_POST['autoplay'] != '' ){
			$autoplay = true;
			//log_it("AUTOPLAY");
		}else{
			$autoplay = false;
		}
		
		$tmpargs['start'] = 50;
		
		$response = array(
					'oembed' => wp_oembed_get( $url ,$tmpargs),
					'embed' => $wp_embed->run_shortcode( '[embed]'.$url.'[/embed]' ),
					'stripped' => stripslashes($_POST['url']),
					'orig' => $_POST['url']
					);
		
		
		if(!$response['oembed']){
			$response['fix'] =  urldecode($url);
			$response['oembed'] = wp_oembed_get( urldecode($url) ,$tmpargs);
			$response['oembed'] = $wp_embed->run_shortcode( '[embed]'.urldecode($url).'[/embed]' );
		}
		
		
		if($autoplay){
			if(strpos($response['embed'],"vimeo")){
				$response['embed'] = str_replace( '?app_id', '?autoplay=1&app_id',$response['embed'] );
			} else if(strpos($response['embed'],"youtube")){ 
				$response['embed'] = str_replace( 'feature=oembed', 'feature=oembed&autoplay=1',$response['embed'] );
			} else { 
				$response['embed'] = str_replace( 'feature=oembed', 'feature=oembed&autoplay=1',$response['embed'] );
			}
			
			$response['autoplay'] = "trying to make it autoplay";
		}
		
		preg_match('/.*t=([0-9]*h?[0-9]*m?[0-9]*)/m', $url, $matches);
		//log_it($url);
		//log_it($response['embed']);
		//log_it($matches);

		if(!empty($matches[1])){
			if($autoplay){	
				//log_it($matches);
				$response['embed'] = str_replace( 'autoplay=1', 'autoplay=1#t='.$matches[1], $response['embed'] );
			}else{
				//log_it($matches);
				$response['embed'] = str_replace( '?', '#t='.$matches[1].'?', $response['embed'] );
			}
		}

		preg_match('/.*start=([0-9]*).*/i', $url, $matches);
		if(!empty($matches[1])){
			$response['embed'] = str_replace( 'feature=oembed', 'feature=oembed&start='.$matches[1], $response['embed'] );
		}
		
		preg_match('/.*end=([0-9]*).*/i', $url, $matches);
		if(!empty($matches[1])){
			$response['embed'] = str_replace( 'feature=oembed', 'feature=oembed&end='.$matches[1], $response['embed'] );
		}
		
		//log_it($matches);
		//log_it($response);
		
		$json = json_encode($response);
		wp_send_json($json);
		
		
	}
	wp_die(); // this is required to terminate immediately and return a proper response
	
}


if(!function_exists("ajax_shortcode_callback")) {
	
	add_action( 'wp_ajax_ajax_shortcode', 'ajax_shortcode_callback' );
	add_action( 'wp_ajax_nopriv_ajax_shortcode', 'ajax_shortcode_callback' );

	function ajax_shortcode_callback() {
		global $wpdb; // this is how you get access to the database

	$tmpshortcode = stripslashes('['.$_POST['shortcode'].']');


	echo $tmpshortcode;


	echo do_shortcode($tmpshortcode);


		wp_die(); // this is required to terminate immediately and return a proper response
	}

}



add_action( 'wp_ajax_tmap_get_external_keywords', 'tmap_get_external_keywords_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_external_keywords', 'tmap_get_external_keywords_callback' );

function tmap_get_external_keywords_callback() {
	global $wpdb; // this is how you get access to the database

	$url =  $_POST['url'];
//echo "maybe? ". $url;
$search_array = get_meta_tags($url);

if (array_key_exists('keywords', $search_array)) {
    echo $search_array['keywords'];
}else{
	print_r($search_array);
	echo $url;
}

	wp_die(); // this is required to terminate immediately and return a proper response
}


add_action( 'wp_ajax_tmap_get_external_meta', 'tmap_get_external_meta_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_external_meta', 'tmap_get_external_meta_callback' );

function tmap_get_external_meta_callback() {
	global $wpdb; // this is how you get access to the database

	$url =  $_POST['url'];

//$contents = getUrlContents($url);
$search_array = get_meta_tags($url);


$tmp_title = file_get_contents($url);
  if(strlen($tmp_title)>0){
  //$title[1]="test";
    $tmp_title = trim(preg_replace('/\s+/', ' ', $tmp_title)); // supports line breaks inside <title>
    preg_match("/\<title\>(.*)\<\/title\>/i",$tmp_title,$title); // ignore case
    $search_array['title'] = $title[1];
  }

//echo "maybe? ". $url;

$json = json_encode($search_array);
wp_send_json($json);

	wp_die(); // this is required to terminate immediately and return a proper response
}




add_action( 'wp_ajax_tmap_get_img_base64', 'tmap_get_img_base64_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_img_base64', 'tmap_get_img_base64_callback' );

function tmap_get_img_base64_callback() {
	global $wpdb; // this is how you get access to the database

//return "please work";
	
	//$image =  $_POST['image'];
	//$url =  $_POST['url'];
	//$ext =  $_POST['ext'];

	if(isset($_POST['url']) and !empty($_POST['url'])){
		$url =  $_POST['url'];
	}

	if(isset($_POST['image']) and !empty($_POST['image'])){
		$url = home_url($_POST['image']);
	}
	
	if(isset($_POST['url']) and !empty($_POST['url'])){
		$ext =  $_POST['ext'];
	}else{
		$ext = "jpg";
	}

//$key = "2ecdb2462e2cfda764399083";

// Encrypt the url using your key
//$url = mcrypt_encrypt(MCRYPT_3DES, $key, $url, MCRYPT_MODE_ECB, "00000000");

// base64 encode
//$url = base64_encode($url);

$content = file_get_contents($url);


$content = base64_encode($content);

print $content;

//print 'data:image/'.$ext.';base64,' . $content;

}



add_action( 'wp_ajax_tmap_get_site_shot', 'tmap_get_site_shot_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_site_shot', 'tmap_get_site_shot_callback' );

function tmap_get_site_shot_callback() {
	global $wpdb, $screenshotlayer_key, $screenshotlayer_key2; // this is how you get access to the database
	
	log_break("get siteshot for ".$_POST['url']);
	
	//--log-it--


	
	
	
	
	//$testurl =  $_POST['url'];

/*
	$layertest = strpos($testurl,"screenshotlayer");
	
	if($layertest){
		
		$newstr = substr_replace($testurl, $screenshotlayer_key, strpos($testurl,"access_key") + 11, 0);
		
		log_it("HERE ".$newstr);
		
		$url = $newstr;

		
	}else{
		$url = $testurl;
	}
	*/
	$usekey = "";
	$url = "http://image.thum.io/get/noanimate/width/700/crop/794/".$_POST['url'];
	
	$file_info = new finfo(FILEINFO_MIME_TYPE);
	$mime_type = $file_info->buffer(file_get_contents($url));
	log_it("mimetype is ".$mime_type);
	
	if($mime_type == "image/png"){
		$content = file_get_contents($url);
		log_it("screenshotlayer not needed");
	}else{
		echo "error";
		wp_die();
		/*
		$testurl = "http://api.screenshotlayer.com/api/capture?access_key=".$screenshotlayer_key."&url=".$_POST['url']."&viewport=1360x900&width=300&format=png";

		$url = $testurl;
		//$key = "2ecdb2462e2cfda764399083";

		// Encrypt the url using your key
		//$url = mcrypt_encrypt(MCRYPT_3DES, $key, $url, MCRYPT_MODE_ECB, "00000000");

		// base64 encode
		//$url = base64_encode($url);
		log_it($url);
		$content = file_get_contents($url);

		log_it(gettype($content));
		log_it($content);

		$checkJSON = json_decode($content);
		$usekey = $screenshotlayer_key;

		if($checkJSON){
			log_it("screenshot layer key one failed, trying 2nd key.");
			$newstr = substr_replace($testurl, $screenshotlayer_key2, strpos($url,"access_key") + 11, 0);
			$url = $newstr;
			$content = file_get_contents($url);
			$checkJSON2 = json_decode($content);
			$usekey = $screenshotlayer_key2;
			if($checkJSON2){
				log_it("screenshot layer key two also failed, giving up.");
				echo "error";
				wp_die();
			}else{
				log_it("2nd key worked.");
			}
		}
		*/
	}
	
	
	
	
	
	

	$content = base64_encode($content);



	//require_once
	//require_once(get_stylesheet_directory() . '/includes/simple_html_dom.php');
	//require_once(get_stylesheet_directory() . '/includes/url_to_absolute/url_to_absolute.php');

	$alternate_images = '<div id="alt_images">';
	
	//$result_out = print_r($result ,true);

	//log_it($result_out);

	$alternate_images .= '</div>';

	$alternate_js = 'jQuery.post({
			type:"post",
			timeout:20000,
			url:ajax_object.ajax_url,
			//dataType: "json",
			data:{\'action\': \'tmap_get_site_images\',\'url\': \''.$url.'\',\'orig_url\': \''.$_POST['orig_url'].'\' },
			error:function(textStatus,textStatus) {
			console.log(\'Got this error from the server: \' + textStatus + " " + textStatus);
			},
			success:function(response) {
				
				jQuery("#thumb_options").html(response);
			
				//realID = $(element_ident).html();
			
				//setCookie(\'tmap_elementid\'+elementid+\'_ID\',realID);
				
				//window[\'elementid\'+elementid+\'_ID\'] = realID;
				
				//log(window.elementid1_ID + " -WINDOW-" + window.elementid3_ID);
				
				//log("real id is: "+realID);
				
				//jQuery("img.thumb_option").each(function () {
					
					//var tmpsrc = $(this).attr("src");
					
					//if(UrlExists(tmpsrc)){
						//var tmpexist = "true";
					//}else{
						//var tmpexist = "false";
					//}
					
					//console.log(tmpsrc+" - "+tmpexist);
					
				//});
		
		
			}
		});';


	//echo $content;

	/*
	print '<div class="overlay"></div>
	<img alt="'.$url.'" src=""/>
	<span class="click">Click to Replace</span>
	*/

		 print '<div class="overlay"></div>
	<img alt="'.$url.'" src="data:image/png;base64,' . $content . '"/>
	<span class="click">Click To Replace</span>
	'.$alternate_images.'
	<script type="text/javascript">
	jQuery(document).ready(function( $ ) {
		
		$(\'#webpage_thumb_div .click\').mouseover(function() {
		  $(\'.overlay\').animate({
			opacity: 0.5,
		  }, 100);
		}).mouseout(function() {
		  $(\'.overlay\').animate({
			opacity: 0,
		  }, 100);
		});
		
		jQuery("#web_post_cred_thumb_div").prepend("<span id=\'wpctdsrc\' data-tmpsrc=\"'.$url.'\"></span>");
					
		$("input[name=web_post_auto_thumb]").attr("value","'.$url.'");

		
		$(\'#webpage_thumb_div .click\').click(function(){
		
				
				var $imghref = $("#web_post_cred_thumb_div #wpctdsrc").data("tmpsrc");
				console.log($imghref);
				
			
			$("#webpage_thumb_div").hide(100);
			$("input[name=web_post_auto_thumb]").attr("value","");
		
		
			jQuery("#web_post_cred_thumb_div").show(100,function(){
				jQuery("#web_post_cred_thumb_div img").remove();
				
				jQuery("#web_post_cred_thumb_div").slim();
			
			//jQuery("#web_post_cred_thumb_div").slim("load","/wp-content/themes/soledad-child/includes/imageGrab.php?key='.$usekey.'&url='.$_POST['orig_url'].'&viewport=1360x900&width=700&format=png",{}, function(error, data){});
				
				
				jQuery("#web_post_cred_thumb_div").slim("load","/wp-content/themes/soledad-child/includes/imageGrab.php?url='.$url.'",{}, function(error, data){});
			
			jQuery("#web_post_cred_thumb_div").after(\'<div id="thumb_options" style="display: none;"></div>\');
			jQuery("#web_post_cred_thumb_div").after(\'<div id="lookingLoading" ><span class="title">looking for alternative images...</span>\
			<span class="subtitle">(This can take up to 30 seconds)</span>\
			<span class="loading"></span></div>\');
							

	'.$alternate_js.'
		
	
			
			});
		

		});





	});
	</script>

	';



//print '<img src="http://images.thumbshots.com/image.aspx?cid=l9TIk3GjtZs%3d&v=1&xurl=' . urlencode($url) . '"/>';

//echo '<img src="http://images.thumbshots.com/image.aspx?cid=l9TIk3GjtZs%3d&v=1&w=480&url=http%3a%2f%2fwww.yahoo.com" border="1" alt="Preview by Thumbshots.com" />';

	//header('Content-type: image/png');
    //imagepng($url);

	wp_die(); // this is required to terminate immediately and return a proper response
}

add_action( 'wp_ajax_tmap_get_site_images', 'tmap_get_site_images_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_site_images', 'tmap_get_site_images_callback' );

function tmap_get_site_images_callback() {

	

	$url =  $_POST['url'];
	//error_log( "checking".$url );
	$content = file_get_contents($url);


	$content = base64_encode($content);

	
	//print '<script>alert("worked");</script>';
	
	//wp_die(); // this is required to terminate immediately and return a proper response
	
	//require_once
	require_once(get_stylesheet_directory() . '/includes/simple_html_dom.php');
	require_once(get_stylesheet_directory() . '/includes/url_to_absolute/url_to_absolute.php');
	
	$alternate_images = '<div id="alt_images">';
	
	$alternate_js = '<script>';

	$alternate_js .= '
	
	jQuery("#thumb_options").append(\'<span class="title">Click an image below to load alternative</span>\');
	
	jQuery("#thumb_options").append(\'<img class="thumb_option_orig" src="data:image/png;base64,' . $content . '"/>\');
	
	
	
	';

	//$html = file_get_html($_POST['orig_url']);

	$rawhtml = file_get_contents($_POST['orig_url']);
	//log_it($rawhtml);
	//$html = str_get_html($_POST['orig_url']);
	
	$tmpID = 1;
	
	if($rawhtml){

		$ctx = stream_context_create(array('http'=>
			array(
				'timeout' => 2,  //1200 Seconds is 20 Minutes
			)
		));

		$clean_matches = array();
		/*
		foreach($html->find('img') as $element) {
			//$alternate_js .= 'jQuery("#thumb_options").append(\'<img class="thumb_option" id="thumb_option'.$tmpID.'" src="'.url_to_absolute($_POST['orig_url'], $element->src).'">\');';
			array_push($clean_matches, url_to_absolute($_POST['orig_url'], $element->src));
			//log_it("foreach");
			$tmpID++;
		}
		*/
		
		$re = '/[\'|"]([^\'"()]*(png|jpg))[\'|"]/m';
		preg_match_all($re, $rawhtml, $matches, PREG_SET_ORDER, 0);		
		
		foreach($matches as $regimg) {
			//$alternate_js .= 'jQuery("#thumb_options").append(\'<img class="thumb_option" id="thumb_option'.$tmpID.'" src="'.url_to_absolute($_POST['orig_url'], $regimg[]).'">\');';
			//log_it($regimg);
			$cleanURL = str_replace("\\/", "/", $regimg[1]);
			array_push($clean_matches, url_to_absolute($_POST['orig_url'], $cleanURL));
			$tmpID++;
		}
		
		//$re = '/[\'|"]([^\'"()]*\.css)[\'|"]/m';
		$re = '/[\'|"|(]?([^\'"()]*\.css)[\'|"|)|\?]/m';
		preg_match_all($re, $rawhtml, $cssMatches, PREG_SET_ORDER, 0);	
		$matchCount = count($cssMatches);
		log_it($cssMatches);
		$matchMax = 1;
		$tried = 0;
		for ($x = 0; ($tried <= $matchMax && $x <= $matchCount-1); $x++) {
			if( $cssMatches[$x][1] != "text/css" 
			&& strpos($cssMatches[$x][1], "plugins") === false
			&& strpos($cssMatches[$x][1], "opensans") === false
			&& strpos($cssMatches[$x][1], "carousel") === false
			&& strpos($cssMatches[$x][1], "qunit") === false
			&& strpos($cssMatches[$x][1], "jQuery") === false
			&& strpos($cssMatches[$x][1], "font") === false){
				$cleanCSSMatch = str_replace("\\/", "/", $cssMatches[$x][1]);
				$cleanCSSMatch = str_replace("\/", "/", $cleanCSSMatch);
				log_it("css file found: ".url_to_absolute($_POST['orig_url'], $cleanCSSMatch));
				ini_set('default_socket_timeout', 2); // 2 seconds
				$TMPrawhtml = file_get_contents(url_to_absolute($_POST['orig_url'], $cleanCSSMatch), false, $ctx);
				
				$re = '/[\'|"|(]?([^\'"()]*(png|jpg))[\'|"|)]/m';
				preg_match_all($re, $TMPrawhtml, $cssIMGmatches, PREG_SET_ORDER, 0);		
				
				foreach($cssIMGmatches as $cssimg) {
					$cleanURL = str_replace("\\/", "/", $cssimg[1]);
					$cleanURL = str_replace("\/", "/", $cleanURL);
					array_push($clean_matches, url_to_absolute($_POST['orig_url'], $cleanURL));
					log_it("found css img: ".$cleanURL[1]);
					$tmpID++;
				}
				
				$tried++;
			}else{
				//log_it("bad match: ".url_to_absolute($_POST['orig_url'], $cssMatches[$x][1]));
				//$x--;
				//$matchMax++;
			}
		} 
		
		//log_it($clean_matches);
		$clean_matches = array_unique($clean_matches);
		//log_it($clean_matches);
		
		foreach($clean_matches as $key => $value) {
			
			
			$URL  = url_to_absolute($_POST['orig_url'], $value);
			/*
			$curlHandle = curl_init();
			curl_setopt($curlHandle, CURLOPT_URL, $URL);
			curl_setopt($curlHandle, CURLOPT_HEADER, true);
			curl_setopt($curlHandle, CURLOPT_NOBODY  , true);  // we don't need body
			curl_setopt($curlHandle, CURLOPT_RETURNTRANSFER, true);
			curl_exec($curlHandle);
			$response = curl_getinfo($curlHandle, CURLINFO_HTTP_CODE);
			curl_close($curlHandle); // Don't forget to close the connection

			log_it("image test: ".$URL." - Status: ".$response); 
			
			*/
			
			$alternate_js .= 'jQuery("#thumb_options").append(\'<img class="thumb_option" id="thumb_option'.$key.'" src="'.$URL.'">\');';
		}
		
		
		
/*
		foreach($html->find('img') as $element) {
			//$result[] = url_to_absolute($url, $element->src);
			//log_it($element->src);
			//$alternate_images .= '<img class="thumb_option" src="'.url_to_absolute($_POST['orig_url'], $element->src).'" width="150">';
			$alternate_js .= 'jQuery("#thumb_options").append(\'<img class="thumb_option" id="thumb_option'.$tmpID.'" src="'.url_to_absolute($_POST['orig_url'], $element->src).'">\');';
			//log_it("foreach");
			$tmpID++;
		}
		*/
		
	}
	
	$alternate_js .= '
	

	
	jQuery(\'.thumb_option_orig\').click(function(){
			jQuery("#web_post_cred_thumb_div").slim("load","/wp-content/themes/soledad-child/includes/imageGrab.php?key=8c0fc9f06a01db70f6b8d0e163df85ba&url='.$url.'&viewport=1360x900&width=700&format=png",{}, function(error, data){});
	});
			

			window.thumbCount = jQuery(".thumb_option").length;

			if(jQuery(".thumb_option").length <= 1){
				   console.log("nothing left");
				   
				   jQuery("#thumb_options").html(\'<span class="title">No alternative images found</span>\');
					jQuery("#lookingLoading").fadeOut(200,function(){
					   jQuery("#thumb_options").fadeIn();
				   });
				   
			   }else{

			jQuery("img.thumb_option").each(function( index ) {
	
				var $tmp_thumb_id = jQuery(this).attr("id");
	
				//console.log($tmp_thumb_id);
				
				//var img = jQuery("#"+$tmp_thumb_id);
				var theImage = new Image();
				theImage.src = jQuery(this).attr("src");
				//theImage.id = "tmp"+$tmp_thumb_id;
				
				//if(UrlExists(theImage.src)){
					//console.log(theImage.src+": true");
				//}else{
					//console.log(theImage.src+": false");
				//}
				
				//console.log(jQuery(this)[0].naturalHeight);
				
				
				theImage.onerror = function () {
				   console.error("Cannot load image, removing");
				   //do something else...
				   jQuery("#"+$tmp_thumb_id).remove();
				}
				
				theImage.onload = function() {
					//console.log("Width: " + theImage.width);
					//console.log("Height: " + theImage.height);
					if(theImage.width <= 500 || theImage.height <= 400 ){
						console.log("removing "+$tmp_thumb_id);
						jQuery("#"+$tmp_thumb_id).remove();
					};

					//theImage.remove();
				};
				
				window.thumbCount = window.thumbCount-1;
				console.log(window.thumbCount);
				if(window.thumbCount == 0){
					console.log(jQuery(".thumb_option").length);
					setTimeout(function(){
					   console.log(jQuery(".thumb_option").length);
					   if(jQuery(".thumb_option").length <= 1){
						   console.log("nothing left");
						   
						   jQuery("#thumb_options").html(\'<span class="title">No alternative images found</span>\');
						    jQuery("#lookingLoading").fadeOut(200,function(){
							   jQuery("#thumb_options").fadeIn();
						   });
						   
					   }else{
					   
						   //jQuery("#lookingLoading").fadeOut();
						   jQuery("#lookingLoading").fadeOut(200,function(){
							   jQuery("#thumb_options").fadeIn();
						   });
							jQuery(\'.thumb_option\').click(function(){
								var $tmp_thumb_src = jQuery(this).attr("src");
								jQuery("#web_post_cred_thumb_div").slim("load","/wp-content/themes/soledad-child/includes/imageGrab.php?url="+$tmp_thumb_src,{}, function(error, data){});
							});

					   
					   
					   };
					}, 2000);
				}
				
			});

};

 //	jQuery(document).ready(function() {
//		console.log(jQuery(".thumb_option").length);
//	});		
			</script>';
	
	$alternate_images .= '</div>';

	print $alternate_js;

	wp_die(); // this is required to terminate immediately and return a proper response

}

add_action( 'wp_ajax_tmap_get_page_content', 'tmap_get_page_content_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_page_content', 'tmap_get_page_content_callback' );

function tmap_get_page_content_callback() {
//log_break("getting post");
global $wpdb; // this is how you get access to the database

if ( !empty($_POST['name']) ) {
	$page = get_page_by_title( $_POST['name'] );
	$request_id =  $page->ID;
}else{
	if(is_numeric($_POST['id'])){
		$request_id =  $_POST['id'];
	}else{
		$request_id = $wpdb->get_var( "SELECT ID FROM $wpdb->posts WHERE post_title = '" . $_POST['id'] . "'" );
		if(!$request_id){
			//log_it("tmap_get_tooltip_excerpt_callback error: not found");
			wp_die();
		}
	}
}

// would echo post 7's content up until the <!--more--> tag
$tmp_post = get_post($request_id); 
//$excerpt = $tmp_post->content;

//$json_output =  json_encode($tmp_post->post_content);
//$output =  json_encode($tmp_post);
//wp_send_json($json_output);

//$content = '<div class="inner-post-entry">'.$tmp_post->post_content.'</div>';

$content = apply_filters('the_content', $tmp_post->post_content);


// add edit link if user is allowed to edit requested post
if(current_user_can("edit_post",$request_id)){
	$content .= '<br><br> <a href="'.get_edit_post_link($request_id).'" class="tmap_edit ui-button" target="_editPost">Edit</a>';
}


echo do_shortcode('<div class="post-entry"><div class="inner-post-entry">'.$content.'</div></div>');
wp_die(); // this is required to terminate immediately and return a proper response
}


add_action( 'wp_ajax_tmap_get_page_excerpt', 'tmap_get_page_excerpt_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_page_excerpt', 'tmap_get_page_excerpt_callback' );

function tmap_get_page_excerpt_callback() {

global $wpdb; // this is how you get access to the database

$request_id =  $_POST['id'];

// would echo post 7's content up until the <!--more--> tag
$tmp_post = get_post($request_id); 
//$excerpt = $tmp_post->content;

//$json_output =  json_encode($tmp_post->post_content);
//$output =  json_encode($tmp_post);
//wp_send_json($json_output);

//$content = '<div class="inner-post-entry">'.$tmp_post->post_content.'</div>';

$content = apply_filters('the_content', $tmp_post->post_excerpt);

echo do_shortcode('<div class="post-entry"><div class="inner-post-entry">'.$content.'</div></div>');
wp_die(); // this is required to terminate immediately and return a proper response
}


add_action( 'wp_ajax_tmap_get_tooltip_excerpt', 'tmap_get_tooltip_excerpt_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_tooltip_excerpt', 'tmap_get_tooltip_excerpt_callback' );

function tmap_get_tooltip_excerpt_callback() {

	//--log-it--

	global $wpdb, $tooltip_excerpt_length; // this is how you get access to the database

	if(is_numeric($_POST['id'])){
		$request_id =  $_POST['id'];
	}else{
		$request_id =  "1555";
		//$posttitle = 'About';
		$request_id = $wpdb->get_var( "SELECT ID FROM $wpdb->posts WHERE post_title = '" . $_POST['id'] . "'" );
		if(!$request_id){
			log_it("tmap_get_tooltip_excerpt_callback error: not found");
			wp_die();
		}
	}
	//log_break("getting excerpt: ".$_POST['id']);


	$tmp_post = get_post($request_id); 

	//log_it($tmp_post);
	//$content = '<div class="inner-post-entry">'.$tmp_post->post_content.'</div>';

	$title = apply_filters('the_title', $tmp_post->post_title);
	$content = apply_filters('the_content', $tmp_post->post_content);
	$excerpt = apply_filters('the_content', $tmp_post->post_excerpt);
	$click = '';

	if($excerpt == ''){
		$excerpt = substr($content, 0, $tooltip_excerpt_length);
	}

	if(strlen($content) > $tooltip_excerpt_length){
		$excerpt .= '...<br>'; //add char count for debuging
		$click = ' Click for more information';
	}

	// add edit link if user is allowed to edit requested post
	if(current_user_can("edit_post",$request_id)){
		$click .= '<br><br> <a href="'.get_edit_post_link($request_id).'" class="tmap_edit ui-button" target="_editPost">Edit</a>';
	}


	echo do_shortcode('
	<span class="tooltip_title">
		'.$title.'
	</span>
	<div class="tooltip_more">
	'.$excerpt.$click.'
	</div>
	<span class="tooltip_width hide">500</span>

	<div class="post-entry hide">
		<div class="inner-post-entry">
			'.$content.'
		</div>
	</div>
	<div class="full_tooltip hide">' .$request_id. '</div>

	');
	wp_die(); // this is required to terminate immediately and return a proper response
}


add_action( 'wp_ajax_tmap_add_tag', 'tmap_add_tag_callback' );
add_action( 'wp_ajax_nopriv_tmap_add_tag', 'tmap_add_tag_callback' );

function tmap_add_tag_callback() {

	if((isset($_POST['post']) && $_POST['post'] != '' ) && (isset($_POST['tag']) && $_POST['tag'] != '' )){
		
		$post_id = (int)$_POST['post'];
		$term = term_exists( (int)$_POST['tag'], 'post_tag' );
		//$termsARRAY = array( (int)$_POST['tag'] );
		$post_terms = wp_get_post_terms( $post_id );
		$termsARRAY = array();
		foreach ($post_terms as $value){
			//print_r($value);
			echo $value->term_id;
			$termsARRAY[] = $value->term_id;
		}
		
		
		if ( $term !== 0 && $term !== null ) {
			print_r($term);
			//echo $term["term_id"];
			$termsARRAY[] = (int)$term["term_id"];
		}
		
		//print_r($termsARRAY);
		//print_r($post_terms);
		
		if(wp_set_post_terms( $post_id, $termsARRAY )){
			echo "worked";
		} else {
			echo "not so much";
		}
		
		echo "good";
		
	}else{
		echo "bad";
	}

echo "done";

};

add_action( 'wp_ajax_tmap_get_post', 'tmap_get_post_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_post', 'tmap_get_post_callback' );

function tmap_get_post_callback() {
global $wpdb; // this is how you get access to the database
$request_id =  $_POST['id'];
// would echo post 7's content up until the <!--more--> tag
$tmp_post = get_post($request_id); 
//$excerpt = $tmp_post->content;
$json_output =  json_encode($tmp_post);
wp_send_json($json_output);
wp_die(); // this is required to terminate immediately and return a proper response
}


add_action( 'wp_ajax_tmap_get_site_content', 'tmap_get_site_content_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_site_content', 'tmap_get_site_content_callback' );

function tmap_get_site_content_callback() {

	$request_url =  $_POST['url'];
$curl = curl_init($request_url);
curl_setopt($curl, CURLOPT_POST, 1);
curl_setopt($curl,CURLOPT_POSTFIELDS,$_POST);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($curl,CURLOPT_USERAGENT,'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.13) Gecko/20080311 Firefox/2.0.0.13');

$data = curl_exec($curl);

// do something with $data, transform it however you want...

//echo $data;
//wp_die(); 

if(substr($request_url, -1) == '/') {
    $request_url = substr($string, 0, -1);
}

//$homepage = file_get_contents('http://theeverythingcompany.com/');



$doc = new DOMDocument();
@$doc->loadHTML($data);
$xpath = new DOMXpath($doc);
$searchTags = $xpath->query('//img | //link | //script');

$length = $searchTags->length;
for ($i = 0; $i < $length; $i++) {
    $element = $searchTags->item($i);

    if ($element->tagName == 'link')
        $attr = 'href';
    else
        $attr = 'src';

    $src = $element->getAttribute($attr);
    if (!startsWith($src, 'http') && !startsWith($src, '//'))
    {
    if (startsWith($src, '/')){
   		$element->setAttribute($attr, $request_url . $src);
    }else{
    	$element->setAttribute($attr, $request_url . "/" . $src);
    }
    
        
    }
}

/*$elem = $doc->getElementsByTagName('script')->item(0);

 $src = $elem->getAttribute('src');

    $tmpsrc = file_get_contents($src);
// set innerHTML
$elem->innerHTML = $tmpsrc;

*/

$searchTags2 = $xpath->query('//script');

$length2 = $searchTags2->length;
for ($i = 0; $i < $length2; $i++) {
    $element = $searchTags2->item($i);

    $src = $element->getAttribute('src');

    $tmpsrc = file_get_contents($src);
	
	$scrtext = $doc->createTextNode($tmpsrc);
	$doc->appendChild($element);
	
	$element->appendChild($scrtext);
	$element->removeAttribute('src');

}

/*
$script = $dom->getElementsByTagName('script');

$remove = [];
foreach($script as $item)
{
  $remove[] = $item;
}

foreach ($remove as $item)
{
  $item->parentNode->removeChild($item); 
}
*/

$result = $doc->saveHTML();
echo $result;

//echo $homepage;
wp_die(); 

}


/*function tmap_get_cookie() {
	global $wpdb; // this is how you get access to the database

	$cookie =  $_POST['url'];


if (isset($_COOKIE["abc"]))
{
  echo '<br><center><a href="http://om-p.com/" target="_blank">click here</a></center></b>';
}


	wp_die(); // this is required to terminate immediately and return a proper response
}


add_action( 'wp_ajax_tmap_get_external_meta', 'tmap_get_external_meta_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_external_meta', 'tmap_get_external_meta_callback' );
*/

add_action( 'wp_ajax_tmap_save_extra_profile_fields_ajax', 'tmap_save_extra_profile_fields_ajax_callback' );
add_action( 'wp_ajax_nopriv_tmap_save_extra_profile_fields_ajax', 'tmap_save_extra_profile_fields_ajax_callback' );

function tmap_save_extra_profile_fields_ajax_callback() {

//echo "going";

$current_user = wp_get_current_user();

$user_id = $current_user->ID;

	if ( !current_user_can( 'edit_user', $user_id ) ){
		echo "Error " . $_POST['metakey'] . $_POST['metavalue'];
		wp_die();
		}
//echo "done";
	/* Copy and paste this line for additional fields. Make sure to change 'twitter' to the field ID. */
	update_user_meta( $user_id, $_POST['metakey'], $_POST['metavalue'] );
	echo "Saved " . $_POST['metakey'] . $_POST['metavalue'];

wp_die();

}


add_action( 'wp_ajax_tmap_saveThoughtIMG', 'tmap_saveThoughtIMG_callback', 1);
add_action( 'wp_ajax_nopriv_tmap_saveThoughtIMG', 'tmap_saveThoughtIMG_callback', 1);

function tmap_saveThoughtIMG_callback() {/*np++*/

//$thumbnail_id = _uploadImageToMediaLibrary2($_POST['id'] , $_POST['base64'], "thumb");
	$postID = $_POST['id'];
	require_once(ABSPATH ."wp-load.php");
    require_once(ABSPATH."wp-admin/includes/image.php");
    require_once(ABSPATH."wp-admin/includes/file.php");
    require_once(ABSPATH."wp-admin/includes/media.php");
	
	$ext = pathinfo($_POST['name'], PATHINFO_EXTENSION);
	error_log( "-".$ext."-" );
	if(!$ext || empty($ext) || $ext == '' || $ext == " "){ 
		$ext = "jpg";
	}
	$pretmp = date("YmdHis").rand(1262055681,1262055681).".".$ext;
	
	//log_it("test");
	$tmp_filepath = plugin_dir_path( __FILE__ ).'temp/'.$pretmp;

	$imageData = base64_decode(preg_replace('#^data:image/\w+;base64,#i', '', $_POST['base64']));
	$source = imagecreatefromstring($imageData);
	$imageSave = imagejpeg($source,$tmp_filepath,100);

    $tmp = download_url(  plugin_dir_url( __FILE__ ).'temp/'.$pretmp );
    $desc = "dragdrop_".$postID;
    $file_array = array();

	$file_array['name'] = $pretmp;
    $file_array['tmp_name'] = $tmp;
	
	if ( is_wp_error( $tmp ) ) {
        @unlink($file_array['tmp_name']);
        $file_array['tmp_name'] = '';
    }
	
	$id = media_handle_sideload( $file_array, $postID, $desc);
	
	if ( is_wp_error($id) ) {
        @unlink($file_array['tmp_name']);
        return $id;
    }

	unlink(get_stylesheet_directory().'/temp/'.$pretmp);
	
	$response = array(
					'thumbnail_id' => $id,
					'url' => wp_get_attachment_url($id),
					);
	
	$json = json_encode($response);
	wp_send_json($json);
	
	
	wp_die();
}

add_action( 'wp_ajax_tmap_saveFeaturedIMG', 'tmap_saveFeaturedIMG_callback', 1);
add_action( 'wp_ajax_nopriv_tmap_saveFeaturedIMG', 'tmap_saveFeaturedIMG_callback', 1);

function tmap_saveFeaturedIMG_callback() {/*np++*/
	
	$current_user = wp_get_current_user();
	$postID = $_POST['id'];
	
	if(is_user_logged_in() &&( $current_user->ID == $post->post_author || current_user_can("edit_thought",$postID) || current_user_can("edit_thought_".$postID) || current_user_can("edit_others_thoughts_NVM"))){
		$die = false;
	}else{
		$output['error'] =  "You do not have permission to do this.";
		wp_send_json_error($output);
		wp_die();
	}

	$output = [];
	//log_it($_POST);
	//log_it("tmap_saveFeaturedIMG_callback");
	//$thumbnail_id = _uploadImageToMediaLibrary2($_POST['id'] , $_POST['base64'], "thumb");
	
	require_once(ABSPATH ."wp-load.php");
    require_once(ABSPATH."wp-admin/includes/image.php");
    require_once(ABSPATH."wp-admin/includes/file.php");
    require_once(ABSPATH."wp-admin/includes/media.php");
	
	$ext = pathinfo($_POST['name'], PATHINFO_EXTENSION);
	//error_log( "-".$ext."-" );
	if(!$ext || empty($ext) || $ext == '' || $ext == " "){ 
		$ext = "jpg";
	}
	$pretmp = date("YmdHis").rand(1262055681,1262055681).".".$ext;
	
	
	$tmp_filepath = plugin_dir_path( __FILE__ ).'temp/'.$pretmp;

	$imageData = base64_decode(preg_replace('#^data:image/\w+;base64,#i', '', $_POST['base64']));
	$source = imagecreatefromstring($imageData);
	$imageSave = imagejpeg($source,$tmp_filepath,100);

    $tmp = download_url(  plugin_dir_url( __FILE__ ).'temp/'.$pretmp );
    $desc = "dragdrop_".$postID;
    $file_array = array();

	$file_array['name'] = $pretmp;
    $file_array['tmp_name'] = $tmp;
	
	if ( is_wp_error( $tmp ) ) {
		$output['error'] = "download_url error";
        @unlink($file_array['tmp_name']);
        $file_array['tmp_name'] = '';
    }
	
	
	
	$origID = get_post_thumbnail_id($postID);
	if(is_numeric($origID)){
		/*
		wp_update_post(
			array(
				'ID' => $origID, 
				'post_parent' => 0
			)
		);
		*/
		wp_delete_attachment( $origID );
	}
	
	$id = media_handle_sideload( $file_array, $postID, $desc);
	
	if ( is_wp_error($id) ) {
		$output['error'] = "media_handle_sideload error";
        @unlink($file_array['tmp_name']);
        //return $id;
    }

	unlink(get_stylesheet_directory().'/temp/'.$pretmp);
	
	$output['thumbnail_id'] = $id;
	$output['url'] = wp_get_attachment_url($id);
	
	
	if(!set_post_thumbnail( $postID, $id )){
		$output['error'] = "set_post_thumbnail error";
	}
	
	if(isset($output['error']) && $output['error'] != ""){
		wp_send_json_error($output);
	}else{
		wp_send_json_success($output);
	}
	//$json = json_encode($output);
	//wp_send_json($json);
	
	
	wp_die();
}

add_action( 'wp_ajax_tmap_deleteFeaturedIMG', 'tmap_deleteFeaturedIMG_callback', 1);
add_action( 'wp_ajax_nopriv_tmap_deleteFeaturedIMG', 'tmap_deleteFeaturedIMG_callback', 1);

function tmap_deleteFeaturedIMG_callback() {/*np++*/
	
	$current_user = wp_get_current_user();
	$postID = $_POST['id'];
	
	if(is_user_logged_in() &&( $current_user->ID == $post->post_author || current_user_can("edit_thought",$postID) || current_user_can("edit_thought_".$postID) || current_user_can("edit_others_thoughts_NVM"))){
		$die = false;
	}else{
		$output['error'] =  "You do not have permission to do this.";
		wp_send_json_error($output);
		wp_die();
	}

	

	$origID = get_post_thumbnail_id($postID);
	if(is_numeric($origID)){
		/*
		wp_update_post(
			array(
				'ID' => $origID, 
				'post_parent' => 0
			)
		);
		*/
		wp_delete_attachment( $origID );
	}
	
	if(!delete_post_thumbnail( $postID)){
		$output['error'] = "delete_post_thumbnail error";
	}else{
		$output['status'] = "featured image deleted";
	}
	
	
	
	if(isset($output['error']) && $output['error'] != ""){
		wp_send_json_error($output);
	}else{
		wp_send_json_success($output);
	}
	wp_die();
}



/*
==================================================================
						   User Search
==================================================================
*/

add_action( 'wp_ajax_tm_search_users', 'tm_search_users_callback' );
add_action( 'wp_ajax_nopriv_tm_search_users', 'tm_search_users_callback' );

function tm_search_users_callback() {
	$output = [];
	$searchOutput = [];
	$die = true;
	//log_it("searching user start");
	//log_it($_POST);
	//log_it($_REQUEST);
	if(is_user_logged_in()){
		$search = $_REQUEST['search'];
	}else{
		//$output['error'] =  "Search must be defined";
		$output['error'] =  "You do not have permission to do this.";
		wp_send_json_error($output);
		wp_die();
	}
	if(isset($_REQUEST['search']) && $_REQUEST['search'] != '' ){
		$search = $_REQUEST['search'];
	}else{
		$output['error'] =  "Search must be defined";
		wp_send_json_error($output);
		wp_die();
	}
	global $wpdb; // this is how you get access to the database
	//log_it("searching user");
	$qargs=[
		 //'role' => ['Customer'], // use this if you need to query by role at the same time
		 
		 'search'=> '*'.$_REQUEST['search'].'*',
		 //'compare' => 'LIKE',
		 'number'=> -1 // to select all users
	 ];

	$usersQuery=new WP_User_Query($qargs); // instantiate UserQuery with $qargs
	//log_it($usersQuery);
	$users=$usersQuery->get_results(); // get all results as array of WPUser objects
	//log_it($users);
	if ( ! empty( $users ) ) {
		//log_it("found users");
		// Call ultimatemember global variable
		$output['list'] = array();
		global $ultimatemember;
		
		//log_it($ultimatemember->user);
		
		foreach ( $users as $user ) {
			
			um_fetch_user( $user->ID );
			$avatar_uri = um_get_avatar_uri( um_profile('profile_photo'), 32 );
			$userMeta = get_user_meta($user->ID);
			$avatar = '<img src="'.$avatar_uri.'">';
			//log_it( unserialize($userMeta['hide_in_members'][0]));
			$hide = unserialize($userMeta['hide_in_members'][0]);
			//$account_status = $userMeta['account_status'][0];
			//log_it($account_status);
			if( ($hide[0] == "No" || $hide[0] == "") && $userMeta['account_status'][0] == 'approved'){
				array_push($searchOutput,[
				'id' => $user->ID,
				'value' => um_get_display_name($user->ID),
				'label' => um_get_display_name($user->ID)." - ".$userMeta['first_name'][0]." ".$userMeta['last_name'][0],
				'icon' => $avatar_uri,
				]);
			}
			/*
			$output['list'][$user->ID] = array(
				'ID' => $user->ID,
				//'display_name' => $user->display_name,
				'display_name' => um_get_display_name($user->ID),
				'email' => esc_html( $user->user_email ),
				'avitar' => $avatar_uri,
				);
				*/
		}
	}else{
		log_it("no users found");
	};
	
	
	if(isset($output['error']) && $output['error'] != ""){
		wp_send_json_error($output);
	}else{
		wp_send_json_success($searchOutput);
	}
	wp_die();
	wp_die(); // this is required to terminate immediately and return a proper response
}


/*
==================================================================
						   Get Editors
==================================================================
*/


add_action( 'wp_ajax_tmap_thoughtMapGetEditors', 'tmap_thoughtMapGetEditors_callback',1 );
add_action( 'wp_ajax_nopriv_tmap_thoughtMapGetEditors', 'tmap_thoughtMapGetEditors_callback',1 );

function tmap_thoughtMapGetEditors_callback() {/*np++*/
	$output = [];
	$die = true;
	$current_user = wp_get_current_user();
	
	
	if(isset($_POST['mapID']) && $_POST['mapID'] != '' ){
		$mapID = $_POST['mapID'];
	}else{
		$output['error'] =  "mapID must be defined";
		wp_send_json_error($output);
		wp_die();
	}
	
	$post = get_post($mapID);
	
	
	if(is_user_logged_in() &&( $current_user->ID == $post->post_author || current_user_can("edit_thought",$mapID) || current_user_can("edit_thought_".$mapID) || current_user_can("edit_others_thoughts_NVM"))){
		$die = false;
	}else{
		$output['error'] =  "You do not have permission to do this.";
		wp_send_json_error($output);
		wp_die();
	}
	
	global $wpdb;
	// meta-key name
	$capabilities_field_name=$wpdb->prefix.'capabilities';
	//array as argument for our query
	$output['capabilities_field_name'] = $capabilities_field_name;
	$qargs=[
		 //'role' => ['Customer'], // use this if you need to query by role at the same time
		 'meta_query'=>
			 [
				'relation' => 'OR', // optional if you'll need to select more than
									//  one capability just add this and create same array
								   // as down below describing what are you looking for 
				 [
					'key' => $capabilities_field_name,
					'value' => '"'."edit_thought_".$mapID.'"', //rolename placed in "" in json it is quoted
					'compare' => 'LIKE',
				 ],
				 [
					'key' => 'ID',
					'value' => 60,
					'compare' => 'LIKE',
				 ],

		   // here could be same array [key,value,compare]... as above with another capability      
		   // but you'll need to add extra argument showing relationship between them see above 'relation parameter'

			 ],
		 'number'=> -1 // to select all users
	 ];

	$usersQuery=new WP_User_Query($qargs); // instantiate UserQuery with $qargs

	$users=$usersQuery->get_results(); // get all results as array of WPUser objects
	
	$post_author_id = get_post_field( 'post_author', $mapID );
	array_push($users,new WP_User($post_author_id));
	$output['list'] = [];
	
	//echo '<ul>';
	if ( ! empty( $users ) ) {
		// Call ultimatemember global variable
		global $ultimatemember;
		
		//log_it($ultimatemember->user);
		
		foreach ( $users as $user ) {
			
			um_fetch_user( $user->ID );
			
			$avatar_uri = um_get_avatar_uri( um_profile('profile_photo'), 32 );
			
			$output['list'][$user->ID] = array(
				'ID' => $user->ID,
				//'display_name' => $user->display_name,
				'display_name' => um_get_display_name($user->ID),
				'email' => esc_html( $user->user_email ),
				'avitar' => $avatar_uri,
				);
		}
	};
	
	
	//log_it($post_author_id);
	//$user = new WP_User($post_author_id); //1 is the admin ID
	//$output['list'][$user->ID] = esc_html( $user->display_name ) . '[' . esc_html( $user->user_email ) . ']';
	
	//echo '</ul>';
	if(isset($output['error']) && $output['error'] != ""){
		wp_send_json_error($output);
	}else{
		wp_send_json_success($output);
	}
	wp_die();
	
}

/*
==================================================================
						   Change Editors
==================================================================
*/


add_action( 'wp_ajax_tmap_thoughtMapChangeEditors', 'tmap_thoughtMapChangeEditors_callback',1 );
add_action( 'wp_ajax_nopriv_tmap_thoughtMapGetEditors', 'tmap_thoughtMapChangeEditors_callback',1 );

function tmap_thoughtMapChangeEditors_callback() {/*np++*/
	
	$die = true;
	$current_user = wp_get_current_user();
/*
	
	if(isset($_POST['mapID']) && $_POST['mapID'] != '' ){
		$mapID = $_POST['mapID'];
	}else{
		$output['error'] =  "mapID must be defined";
		wp_send_json_error($output);
		wp_die();
	}
	
	*/
	
	foreach (['mapID','task','editor'] as $value){
		// Check for required fields
		if(isset($_POST[$value]) && $_POST[$value] != '' ){
			$$value = $_POST[$value];
			//log_it($mapID);
			$die = false;
		}else{
			$output['error'] .= $value." must be defined";
			wp_send_json_error($output);
			$die = true;
			wp_die();
		}
	}
	
	$post = get_post($mapID);
	
	if(is_user_logged_in() &&( $current_user->ID == $post->post_author || current_user_can("edit_thought",$mapID) || current_user_can("edit_thought_".$mapID) || current_user_can("edit_others_thoughts_NVM"))){
		$die = false;
	}else{
		$output['error'] =  "You do not have permission to do this.";
		wp_send_json_error($output);
		wp_die();
	}
	
	
	if($editor == $post->post_author ){
		$output['error'] .= "You can't remove the owner of the map.";
		wp_send_json_error($output);
		$die = true;
		wp_die();
	}
	
	if($editor == $current_user->ID ){
		$output['error'] .= "You can't remove yourself.";
		wp_send_json_error($output);
		$die = true;
		wp_die();
	}

	$user = new WP_User($editor); //1 is the admin ID
	
	//log_it($user->remove_cap( 'edit_thought_'.$mapID ));
	
	if($task == "remove"){
		$user->remove_cap( 'edit_thought_'.$mapID );
		$output['msg'] = "User removed";
	}else if($task == "add"){
		$user->add_cap( 'edit_thought_'.$mapID );
		$output['msg'] = "User added";
		um_fetch_user( $user->ID );
		tm_send_email( um_user( 'user_email' ), "You've been added", "editor_added",array('{thought_title}','{thought_link}','{thought_edit_link}'),array($post->post_title,get_permalink($mapID),wp_login_url(get_permalink($mapID).'/?tmedit')));
	}
	//log_it($post);
	
	//UM()->mail()->send( um_user( 'user_email' ), 'tm_editor_added' );
	
	
	//log_it(um_user( 'user_email' ));
	
	//log_it($user);
	if(isset($output['error']) && $output['error'] != ""){
		wp_send_json_error($output);
	}else{
		wp_send_json_success($output);
	}
	wp_die();
	
}

/*
==================================================================
						   Get User Maps
==================================================================
*/


add_action( 'wp_ajax_tmap_getUserMaps', 'tmap_getUserMaps_callback',1 );
add_action( 'wp_ajax_nopriv_tmap_getUserMaps', 'tmap_getUserMaps_callback',1 );

function tmap_getUserMaps_callback() {/*np++*/
	$output = [];
	$output['list'] = [];

	global $wpdb;
	if(is_user_logged_in()){
		$current_user = wp_get_current_user();
		
		$args = array(
			'post_type' => 'thought',
			'post_author' => $current_user->ID,
			'order' => 'DESC',
			'orderby' => 'date',
		);
		
		// The Query
		$the_query = new WP_Query( $args );

		// The Loop
		if ( $the_query->have_posts() ) {
			while ( $the_query->have_posts() ) {
				$the_query->the_post();
				$output['list'][get_the_ID()] = array(
					'ID' => get_the_ID(),
					'title' => get_the_title(),
				);
			};
			/* Restore original Post Data */
			wp_reset_postdata();
		} else {
			// no posts found
		}
		
	}

	
	//log_it($post_author_id);
	//$user = new WP_User($post_author_id); //1 is the admin ID
	//$output['list'][$user->ID] = esc_html( $user->display_name ) . '[' . esc_html( $user->user_email ) . ']';
	
	//echo '</ul>';
	if(isset($output['error']) && $output['error'] != ""){
		wp_send_json_error($output);
	}else{
		wp_send_json_success($output);
	}
	wp_die();
	
}


/*
==================================================================
						   New Thought Map
==================================================================
*/


	
	
add_action( 'wp_ajax_tmap_newThoughtmap', 'tmap_newThoughtmap_callback',1 );
add_action( 'wp_ajax_nopriv_tmap_newThoughtmap', 'tmap_saveThoughtMap_callback',1 );

function tmap_newThoughtmap_callback() {/*np++*/
	
	$die = false;
	
	
	//--log-it--
	
	$output = array();
	$output['error'] = "";
	
	//$mapData = sanitize_textarea_field(urldecode($_POST['mapData']));
	//log_it('----------------------------------------------------------');
	//log_it($mapData);
	//log_it('----------------------------------------------------------');

	$current_user = wp_get_current_user();

	// Check if user exists
	if(!is_user_logged_in()){
		$output['error'] =  "You must be logged in to save thoughts.";
		wp_send_json_error($output);
		wp_die();
	};
	

	if($die){
		wp_send_json_error($output);
		wp_die();
	}
	
	$user_id = $current_user->ID;


	
	if(isset($_POST['mapTitle']) && $_POST['mapTitle'] != '' ){
		$newTitle = $_POST['mapTitle'];
	}else{
		$newTitle = "";
	};
	
	if(current_user_can("publish_thoughts")){
		// Create post object
		$post_arr = array(
			'post_title'	=> $newTitle,
			'post_type'		=> 'thought',
			'post_content'	=> " ",
			'post_status'	=> 'publish',
			'post_author'	=> $user_id,
		);

		// Insert the post into the database
		$thought_id = wp_insert_post( $post_arr );
		if($thought_id != "false"){
			$output['newID'] = $thought_id;
			$die = false;
			update_post_meta( $thought_id, 'firstEdit', "yes" );
			wp_send_json_success($output);
		}else{
			$output['error'] = "Something went wrong.";
			wp_send_json_error($output);
		}
		
	}else{
		$output['error'] = "You are not allowed to post thoughts yet.";
		wp_send_json_error($output);
		//wp_die();
	}


	wp_die();
}

/*
==================================================================
						   Save Thought Map
==================================================================
*/


add_action( 'wp_ajax_tmap_saveThoughtmap', 'tmap_saveThoughtMap_callback',1 );
add_action( 'wp_ajax_nopriv_tmap_saveThoughtmap', 'tmap_saveThoughtMap_callback',1 );

function tmap_saveThoughtMap_callback() {/*np++*/
	$current_user = wp_get_current_user();
	$die = true;
	
	$post = get_post($_POST['id']);
	
	//log_it($current_user);
	//log_it($post);
	
	
	
	if(is_user_logged_in() &&( $current_user->ID == $post->post_author || current_user_can("edit_thought",$post->ID) || current_user_can("edit_thought_".$_POST['id']) || current_user_can("edit_others_thoughts3"))){
		$die = false;
	}else{
		$output['error'] =  "You do not have permission to do this.";
		wp_send_json_error($output);
		wp_die();
	}
	
	//--log-it--
	
	$output = array();
	$output['error'] = "";
	
	$mapData = sanitize_textarea_field(urldecode($_POST['mapData']));
	//log_it('----------------------------------------------------------');
	//log_it($mapData);
	//log_it('----------------------------------------------------------');

	$current_user = wp_get_current_user();

	// Check if user exists
	if(!is_user_logged_in()){
		$output['error'] =  "You must be logged in to save thoughts.";
		wp_send_json_error($output);
		wp_die();
	};
	
	// Check for post id
	if(isset($_POST['id']) && $_POST['id'] != '' ){
		$thought_id = $_POST['id'];
	}else{
		$output['error'] =  "id must be defined";
		wp_send_json_error($output);
		wp_die();
	}
	
	if($die){
		wp_send_json_error($output);
		wp_die();
	}
	
	// Check for map data
	if(isset($_POST['mapData']) && $_POST['mapData'] != '' ){
		//log_it('----------------------------------------------------------');
		//log_it($_POST['mapData']);
		//log_it('--------------------------MID--------------------------------');
		$mapDataNVM = wp_kses(urldecode($_POST['mapData']),array(
			'br' => array(),
			'em' => array(),
			'strong' => array(),
			'center' => array(),
			'b' => array(),
			'hr' => array(),
			'h1' => array(),
			'h2' => array(),
			'h3' => array(),
			'h4' => array(),
			'h5' => array(),
			'p' => array(),
			'i' => array(),
			'img' => array(),
			'div' => array(),
			'span' => array(),
			'pre' => array(),
			
			)
		);
		$allowed_tags = wp_kses_allowed_html( 'post' );
		//log_it($allowed_tags);
		$mapData = wp_kses(urldecode($_POST['mapData']),$allowed_tags);
		
		//log_it($mapData);
		//log_it('----------------------------------------------------------');
		$die = false;
	}else{
		$output['error'] .= "mapData must be defined";
		//wp_send_json_error($output);
		//wp_die();
	}
	
	// Check for map view data
	if(isset($_POST['mapView']) && $_POST['mapView'] != '' ){
		$mapView = sanitize_textarea_field($_POST['mapView']);
		//log_it($mapView);
		$die = false;
	}else{
		//$output['error'] .= "mapView must be defined";
		//wp_send_json_error($output);
		//wp_die();
	}
	
	// Check for map options data
	if(isset($_POST['mapOptions']) && $_POST['mapOptions'] != '' ){
		$mapOptions = sanitize_textarea_field($_POST['mapOptions']);
		//log_it($mapView);
		$die = false;
	}else{
		$output['error'] .= "mapOptions must be defined";
		//wp_send_json_error($output);
		//wp_die();
	}
	
	if($die){
		wp_send_json_error($output);
		wp_die();
	}
	
	$user_id = $current_user->ID;

	if($thought_id == "new"){
		
		if(isset($_POST['mapTitle']) && $_POST['mapTitle'] != '' ){
			$newTitle = $_POST['mapTitle'];
		}else{
			$newTitle = "";
		};
		
		if(current_user_can("publish_thoughts")){
			// Create post object
			$post_arr = array(
				'post_title'	=> $newTitle,
				'post_type'		=> 'thought',
				'post_content'	=> " ",
				'post_status'	=> 'publish',
				'post_author'	=> $user_id,
			);

			// Insert the post into the database
			$thought_id = wp_insert_post( $post_arr );
			if($thought_id != "false"){
				$output['newID'] = $thought_id;
				$die = false;
			}
			update_post_meta( $thought_id, 'firstEdit', "yes" );
		}else{
			$output['error'] = "You are not allowed to post thoughts yet.";
			wp_send_json_error($output);
			wp_die();
		}
	}else{
		update_post_meta( $thought_id, 'firstEdit', "no" );
	}
	
	// Make sure user can edit post
	//if(current_user_can("edit_post",$thought_id)){
	$current_post = get_post($thought_id);
	//log_it($current_user->ID);
	//log_it(get_post($thought_id));
	if(current_user_can("edit_thought",$thought_id) || $current_post->post_author = $current_user->ID || current_user_can("edit_others_thoughts") || (isset($output['newID']) && $thought_id != "false") ){
		
		//log_it("--USER CAN EDIT POST--");
		//log_it($mapData);
		//log_it('-------');
		$current_data = get_post_meta($thought_id, 'mapData', true);
		$current_view = get_post_meta($thought_id, 'mapView', true);
		$current_options = get_post_meta($thought_id, 'mapOptions', true);
		//log_it($current_data);
		//log_it(addslashes($current_data));
		if(addslashes($current_data) == $mapData && addslashes($current_view) == $mapView){
				//echo "No position changes\n";
				//wp_die();
		}
		
		if(isset($mapOptions) && addslashes($current_data) == $mapData){
				$output['mapData'] = "No data change\n";
		}else if(isset($mapOptions)){
			//log_it($mapData);
			//echo "saving mapData\n";
			if(update_post_meta( $thought_id, 'mapData', $mapData )){
				$output['mapData'] = "finished saving mapData\n";	
			}else{
				$output['error'] = "problem saving mapData\n";
			}
		}
		
		
		if(isset($mapView) && addslashes($current_view) == $mapView){
				$output['mapView'] = "No view change\n";
		}else if(isset($mapView)){
			//echo "saving mapView\n";
			if(update_post_meta( $thought_id, 'mapView', $mapView )){
				$output['mapView'] = "finished saving mapView\n";	
			}else{
				$output['mapView'] = "problem saving mapView\n";
			}
		}
		
		if(isset($mapOptions) && addslashes($current_options) == $mapOptions){
				$output['mapOptions'] = "No data change\n";
		}else if(isset($mapOptions)){
			//echo "saving mapOptions\n";
			if(update_post_meta( $thought_id, 'mapOptions', $mapOptions )){
				$output['mapOptions'] = "finished saving mapOptions\n";	
			}else{
				$output['mapOptions'] = "problem saving mapOptions\n";
			}
		}
		
		
		update_post_meta( $thought_id, 'mapDataBackup2', get_post_meta($thought_id, 'mapDataBackup1', true) );
		update_post_meta( $thought_id, 'mapDataBackup1', $current_data );
		
		$post = array(
			'ID' => $thought_id,
			'post_modified_gmt' => date( 'Y:m:d H:i:s' ),
		);
		wp_update_post( $post );

		
	}
	
	if(isset($output['error']) && $output['error'] != ""){
		wp_send_json_error($output);
	}else{
		wp_send_json_success($output);
	}
	wp_die();

}


/*
==================================================================
						   Thought media
==================================================================
*/

add_action( 'wp_ajax_get_attached_media', 'get_attached_media_callback' );
add_action( 'wp_ajax_nopriv_get_attached_media', 'get_attached_media_callback' );

function get_attached_media_callback() {
	global $wpdb; // this is how you get access to the database
	if(isset($_POST['id']) and !empty($_POST['id'])){
		$media = get_attached_media( 'image', (int) $_POST['id'] );
	}
	$json = json_encode($media);
	wp_send_json($json);
	wp_die(); // this is required to terminate immediately and return a proper response
}


add_action( 'wp_ajax_tmap_remove_user_thought_media', 'tmap_remove_user_thought_media_callback' );
add_action( 'wp_ajax_nopriv_tmap_remove_user_thought_media', 'tmap_remove_user_thought_media_callback' );

function tmap_remove_user_thought_media_callback() {
	global $wpdb; // this is how you get access to the database
	$error = true;
	if(is_user_logged_in() && isset($_POST['post'])){
		$output = array();
		$output["test"] = get_post_meta( (int) $_POST['post'] );

		
		if(is_array($output["test"])){
			//$output["meta"] = wp_get_attachment_metadata((int)$_POST['post'],true);
			$output["post"] = get_post((int)$_POST['post'], ARRAY_A);
			if($output["post"]["post_author"] == get_current_user_id()){
				$output["is_author"] = "YES";
				$output["result"] = wp_delete_attachment( (int)$_POST['post'] );
				$error = false;
			}else{
				$output["is_author"] = "NO";
			}
		}

	}else{
		echo "not logged in";
	}
	
	$json = json_encode($output);
	if($error){
		wp_send_json_error($json);
	}else{
		wp_send_json_success($json);
	}
	wp_die(); // this is required to terminate immediately and return a proper response
}



add_action( 'wp_ajax_tmap_get_post_video', 'tmap_get_post_video_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_post_video', 'tmap_get_post_video_callback' );

function tmap_get_post_video_callback() {

	$tmpargs = array();

	if(isset($_POST['post']) && $_POST['post'] != '' ){
		$postID = $_POST['post'];
	}else{
		echo "no post id";
		wp_die();
	}

	if(isset($_POST['autoplay']) && $_POST['autoplay'] != '' ){
		$autoplay = true;
	}else{
		$autoplay = false;
	}

	if(isset($_POST['height']) && $_POST['height'] != '' ){
		$tmpargs['height'] = $_POST['height'];
	}

	if( has_post_format( 'video',$postID ) ){
		if ( get_post_meta( $postID, 'peoples_post_meta_video_link', true )  ){
			$video = get_post_meta( $postID, 'peoples_post_meta_video_link', true );
		}else{
			$video = get_post_meta( $postID, '_format_video_embed', true );
		}

		$oembed = wp_oembed_get( $video ,$tmpargs);
		if($autoplay){
			$oembed = str_replace( '?feature=oembed', '?feature=oembed&autoplay=1', $oembed );
		}
		$response = array(
				'video' => $video,
				'embed' => $oembed
				);

		$json = json_encode($response);
		wp_send_json($json);
		wp_die();
	}



}

add_action( 'wp_ajax_tmap_get_posts', 'tmap_get_posts_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_posts', 'tmap_get_posts_callback' );

function tmap_get_posts_callback() {
	/*
	prepend all id numbers with the following to avoid conflicts:
	1 - posts
	2 - tags
	3 - links
	*/

	$useTransient = false;

	if(isset($_POST['offset']) && $_POST['offset'] != '' ){
		$offset = $_POST['offset'];
	}else{
		$offset = 0;
	}

	if(isset($_POST['perpage']) && $_POST['perpage'] != '' ){
		$perpage = $_POST['perpage'];
	}else{
		$perpage = 10;
	}

	if(isset($_POST['exclude']) && $_POST['exclude'] != '' ){
		$exclude = $_POST['exclude'];
		//log_it($exclude);
	}else{
		$exclude = array();
	}

	if(isset($_POST['getPosts']) && $_POST['getPosts'] != '' ){
		$getPosts = true;
	}else{
		$getPosts = false;
	}

	if(isset($_POST['getLinks']) && $_POST['getLinks'] != '' ){

		$getLinks = true;
		if( is_numeric($_POST['getLinks']) ){
			$linksperpage = $_POST['getLinks'];
		}else{
			$linksperpage = $perpage;
		};
	}else{
		$getLinks = false;
	}

	if(isset($_POST['getPostsfromtag']) && $_POST['getPostsfromtag'] != '' ){
		$getPostsfromtag = true;
	}else{
		$getPostsfromtag = false;
	}


	//echo $_POST['1']." and ".$_POST['2'];
	global $wpdb, $post;

	//--log-it--

	//log_it("----- getting posts -----");

	$postcolor = "green";
	$tagcolor = "#999";
	$linkcolor = "#4444ff";
	$linklinecolor = "#9999ff";
	$linecolor = "#000";

	$postsize = "10";
	$tagsize = "5";
	$linksize = "6";

	$postshape = "sphere";
	$tagshape = "box";
	$linkshape = "diamond";

	/*
	$post = "";
	$tag = "";
	$link = "";
	*/
		$links = array();

		$posts = array();

		$info = array();

		$tagIDs = array();


	if($getPostsfromtag){
		//echo '<pre>'.print_r($tags,true).'</pre>';
		$args=array(
			'post_type' => 'post',
			'post_status' => 'publish',
			//'posts_per_page' => -1,
			'posts_per_page' => $perpage,
			'offset' => $offset,
			'tag_id' => $_POST['getPostsfromtag'],
			'post__not_in' => $exclude,
		);

		//print_r($args);
		$my_query = new WP_Query($args);
		//print_r($my_query);



		if( $my_query->have_posts() ) {



		while ($my_query->have_posts()) : $my_query->the_post();
			//echo "There's already a link: ".get_the_ID();

			$postID = $post->ID;
			$post_tags = get_the_tags($postID);

			array_push($posts, "post".$postID);

			$info["post".$postID] = array(
									'title' => get_the_title($postID),
									'smalltitle' => substr(get_the_title($postID), 0, 25),
									'link' => get_permalink($postID),
									'thumb' => get_the_post_thumbnail_url($postID,"thumbnail"),
									'largethumb' => get_the_post_thumbnail_url($postID),
									'altthumb' => '/wp-content/uploads/2016/05/logo.png',
									'shape' => $postshape,
									'color' => $postcolor,
									'id'	=> $postID,
									'size'	=> $postsize,
									'mediaType'	=> get_post_format($postID)
								);



			//$info[$post2] = get_the_title($post2);

			/*
			$links[$postID] = array(
									'1' => get_post_meta( $postID, 'post1', true ),
									'2' => get_post_meta( $postID, 'post2', true )
									);
									*/
			//$links[$post->ID] = $post->ID;
			//$links[$post->ID]['1'] = $post1;
			//log_it("test");
			if($post_tags){
				foreach ($post_tags as $value){
					array_push($posts, "tag".$value->term_id);
					array_push($tagIDs, "tag".$value->term_id);
					$info["tag".$value->term_id] = array(
										'title' => $value->name,
										'smalltitle' => $value->name,
										'link' => $value->name,
										//'thumb' => $value->name,
										'thumb' => '/wp-content/uploads/2016/05/logo.png',
										'shape' => $tagshape,
										'color' => $tagcolor,
										'id'	=> $value->term_id,
										'size'	=> $tagsize,
										'mediaType'	=> "tag"
									);

					$links[$postID."0".$value->term_id] = array('post1' => "post".$postID,'post2' => "tag".$value->term_id, "color" => $linecolor,'id' => $postID.'-tag-'.$value->term_id);
				}
			}


		endwhile;

		} else {

			$search_array[''] = "not found";

		}
	};


	//echo "checking ".$_POST['1']." and ".$_POST['2']." ";
	if($getPosts){
		//echo '<pre>'.print_r($tags,true).'</pre>';

		$getPostsTest = $_POST['getPosts'];
		//log_it($getPostsTest);
		if($getPostsTest == "random"){
			//log_it("random");
			$args=array(
				'post_type' => 'post',
				'post_status' => 'publish',
				'posts_per_page' => $perpage,
				'offset' => $offset,
				'orderby' => 'rand',
			);
		}else if(is_numeric($getPostsTest)){
			//log_it("is numeric");
			$args=array(
				'post_type' => 'any',
				'post_status' => 'publish',
				'p' => (int)$getPostsTest,
			);
		}else{
			//log_it("else");
			$args=array(
				'post_type' => 'post',
				'post_status' => 'publish',
				'posts_per_page' => $perpage,
				'offset' => $offset
			);
			$useTransient = true;
		}
		// FROM: https://anchor.host/randomization-wp-engine-cache/
		if($useTransient):
			// The Query, pull from transient if exists
			if ( false === ( $my_query = get_transient( 'tmap_get_'.$perpage.'_posts_offset_'.$offset ) ) ) {
				// It wasn't there, so regenerate the data and save the transient
				log_it("generating transient cache");
				$my_query = new WP_Query( $args );
				set_transient( 'tmap_get_'.$perpage.'_posts_offset_'.$offset , $my_query, 10 * MINUTE_IN_SECONDS );
			}else{
				log_it("using transient cache");
			};
		else:
			$my_query = new WP_Query($args);
		endif;
		//log_it($my_query);

		if( $my_query->have_posts() ) {

		//log_it("has posts");

		while ($my_query->have_posts()) : $my_query->the_post();
			//echo "There's already a link: ".get_the_ID();

			$postID = $post->ID;
			$post_tags = get_the_tags($postID);

			array_push($posts, "post".$postID);


			$info["post".$postID] = array(
									'title' => get_the_title($postID),
									'smalltitle' => substr(get_the_title($postID), 0, 25),
									'link' => get_permalink($postID),
									'thumb' => get_the_post_thumbnail_url($postID,"thumbnail"),
									'largethumb' => get_the_post_thumbnail_url($postID),
									'altthumb' => '/wp-content/uploads/2016/05/logo.png',
									'shape' => $postshape,
									'color' => $postcolor,
									'id'	=> $postID,
									'size'	=> $postsize,
									'mediaType'	=> get_post_format($postID)
								);

			//$info[$post2] = get_the_title($post2);

			/*
			$links[$postID] = array(
									'1' => get_post_meta( $postID, 'post1', true ),
									'2' => get_post_meta( $postID, 'post2', true )
									);
									*/
			//$links[$post->ID] = $post->ID;
			//$links[$post->ID]['1'] = $post1;
			//log_it("test");
			if($post_tags){

				foreach ($post_tags as $value){
					array_push($posts, "tag".$value->term_id);
					array_push($tagIDs, "tag".$value->term_id);
					$info["tag".$value->term_id] = array(
										'title' => $value->name,
										'smalltitle' => $value->name,
										'link' => $value->name,
										//'thumb' => $value->name,
										'thumb' => '/wp-content/uploads/2016/05/logo.png',
										'shape' => $tagshape,
										'color' => $tagcolor,
										'id'	=> $value->term_id,
										'size'	=> $tagsize,
										'mediaType'	=> "tag"
									);

					$links[$postID."0".$value->term_id] = array('post1' => "post".$postID,'post2' => "tag".$value->term_id, "color" => $linecolor,'id' => $postID.'-tag-'.$value->term_id);
				}
			}


		endwhile;

		} else {

			$search_array[''] = "not found";

		}
	};

	if($getLinks !== false){
		$args=array(
			'post_type' => 'link',
			'post_status' => 'publish',
			'posts_per_page' => $linksperpage,
			'offset' => $offset
		);

		//print_r($args);
		$my_query = new WP_Query($args);

		if( $my_query->have_posts() ) {



		while ($my_query->have_posts()) : $my_query->the_post();
			//echo "There's already a link: ".get_the_ID();

			$postID = $post->ID;
			$post1 = get_post_meta( $post->ID, 'post1', true );
			$post2 = get_post_meta( $post->ID, 'post2', true );
			$post1_tags = get_the_tags($post1);
			$post2_tags = get_the_tags($post2);

			array_push($posts, "post".$post1);
			array_push($posts, "post".$post2);
			array_push($posts, "link".$postID);

			$info["post".$post1] = array(
									'title' => get_the_title($post1),
									'smalltitle' => substr(get_the_title($post1), 0, 25).'...',
									'link' => get_permalink($post1),
									'thumb' => get_the_post_thumbnail_url($post1,"thumbnail"),
									'largethumb' => get_the_post_thumbnail_url($post1),
									'shape' => $postshape,
									'color' => $postcolor,
									'id'	=> $post1,
									'size'	=> $postsize,
									'mediaType'	=> get_post_format($post1)
								);

			$info["post".$post2] = array(
									'title' => get_the_title($post2),
									'smalltitle' => substr(get_the_title($post2), 0, 25),
									'link' => get_permalink($post2),
									'thumb' => get_the_post_thumbnail_url($post2,"thumbnail"),
									'largethumb' => get_the_post_thumbnail_url($post2),
									'shape' => $postshape,
									'color' => $postcolor,
									'id'	=> $post2,
									'size'	=> $postsize,
									'mediaType'	=> get_post_format($post2)
								);

			$info["link".$postID] = array(
									'title' => "Click to view link",
									'smalltitle' => "link",
									'link' => '/2up?loadlink=yes&post1='.$post1.'&post2='.$post2,
									'thumb' => '',
									'shape' => $linkshape,
									'color' => $linkcolor,
									'id'	=> $postID,
									"size"	=>	$linksize
								);

			//$info[$post2] = get_the_title($post2);

			/*
			$links[$postID] = array(
									'1' => get_post_meta( $postID, 'post1', true ),
									'2' => get_post_meta( $postID, 'post2', true )
									);
									*/
			//$links[$post->ID] = $post->ID;
			//$links[$post->ID]['1'] = $post1;
			//log_it("test");
			if($post1_tags){
				foreach ($post1_tags as $value){
					array_push($posts, "tag".$value->term_id);
					array_push($tagIDs, "tag".$value->term_id);
					$info["tag".$value->term_id] = array(
										'title' => $value->name,
										'smalltitle' => $value->name,
										'link' => $value->name,
										'thumb' => $value->name,
										'shape' => $tagshape,
										'color' => $tagcolor,
										'size'	=> $tagsize,
										'mediaType'	=> "tag"
									);

					$links[$post1."0".$value->term_id] = array('post1' => "post".$post1,'post2' => "tag".$value->term_id, "color" => $linecolor,'id' => $post->ID.'-tag-'.$value->term_id);
				}
			}

			if($post2_tags){
				foreach ($post2_tags as $value){
					array_push($posts, "tag".$value->term_id);
					array_push($tagIDs, "tag".$value->term_id);
					$info["tag".$value->term_id] = array(
										'title' => $value->name,
										'smalltitle' => $value->name,
										'link' => $value->name,
										'thumb' => $value->name,
										'shape' => $tagshape,
										'color' => $tagcolor,
										'size'	=> $tagsize,
										'mediaType'	=> "tag"
									);

					$links[$post2."0".$value->term_id] = array('post1' => "post".$post2,'post2' => "tag".$value->term_id, "color" => $linecolor,'id' => $post->ID.'-tag-'.$value->term_id);
				}
			}

			$links[$postID."0".$post1] = array('post1' => "post".$post1,'post2' => "link".$postID, "color" => $linklinecolor,'id' => $post->ID.'-1');
			$links[$postID."0".$post2] = array('post1' => "link".$postID,'post2' => "post".$post2, "color" => $linklinecolor,'id' => $post->ID.'-2');

		endwhile;

		} else {

			$search_array[''] = "not found";

		}
	};

	foreach ($info as $key => $value){
		if(strpos($key, "tag") !== false){

			$tmpID = str_replace("tag", "", $key);
			$query = new WP_Query( array(
				'post_type' => 'post',
				'post_status' => 'publish',
				'posts_per_page' => -1,  //show all
				'tag_id' => $tmpID
			) );
			$count = $query->found_posts;

			$info[$key]['postnum'] = $count;


			//log_it($tmpID." - ".$count);
		}
	}

	$response = array(
					'links' => $links,
					'post_status' => 'publish',
					'posts' => array_unique($posts),
					'info' => $info,
					'tagIDs' => $tagIDs,
					);


	$json = json_encode($response);
	wp_send_json($json);

	wp_die(); // this is required to terminate immediately and return a proper response
}


add_action( 'wp_ajax_tmap_get_sidebar_content', 'tmap_get_sidebar_content_callback' );
add_action( 'wp_ajax_nopriv_tmap_get_sidebar_content', 'tmap_get_sidebar_content_callback' );

function tmap_get_sidebar_content_callback() {

	global $wpdb, $post; // this is how you get access to the database


	if ( !empty($_POST['name']) ) {
		get_sidebar($_POST['name']);
	}else{
		get_sidebar();
	}

	wp_die(); // this is required to terminate immediately and return a proper response

}






?>